2017-01-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* ess-toolbar.el: Remove redundant ":group 'ess-toolbar".

	* ess-site.el (Rd-mode-hook): Fix buffer-local setting of create-lockfiles.
	(ess-restore-asm-extns): Use remq instead of remassoc.

	* ess-rd.el (Rd-active-mark): Remove.
	(Rd-font): Use region-active-p instead.

	* ess-mode.el (ess-mode-menu): Use :help.

	* ess-menu.el: Remove empty file.

	* ess-inf.el (ess-eval-region-or-function-or-paragraph)
	(ess-eval-region-or-function-or-paragraph-and-step)
	(ess-eval-region-or-line-and-step): Use use-region-p.

	* ess-compat.el: Get rid of support for XEmacs and old Emacsen.

2015-11-18    <rsparapa@mcw.edu>

	* ess-sas-d.el (SAS): fix for issue #249: SAS has no prompt

2015-04-07  Stephen Eglen  <stephen@gnu.org>

	* ess-r-d.el (ess-prefer-higher-bit): Test code to prefer higher
	bit (i.e 64 bit rather than 32 bit) Rterm versions for R-newest.
	Should affect only Windows.

2015-03-18  Sam Steingold  <sds@gnu.org>

	* ess-inf.el (ess-show-buffer-action): Add user option.
	(ess-show-buffer): Use it instead of a hard-coded value.

2015-01-31  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-goto-log): Added Truncated record warning
	to list of error messages.
	(ess-sas-cd): fixed bug for directories with embedded blanks; also
	commented out unnecessary calls to ess-sas-goto-shell because
	ess-sas-cd already calls ess-sas-goto-shell
	(ess-sas-graph-view): fixed wrong directory bug and added support
	for ODS

2013-12-05  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-edit-keys-toggle): the default returns
	to nil; indentation has improved somewhat and will probably
	improve a bit more in the near future

2013-10-19  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-trns.el (ess-transcript-clean-region): use t and nil, not 1
	and 0 for boolean  'buffer-read-only

2013-10-19  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-r-d.el (ess--R-load-ESSR): install.packages need
	type='source' on Mac OS X and Windows

2013-10-13  Henning Redestig  <henning@hemulen>

	* ess-roxy.el (ess-roxy-mode-map): better key-mappings and
	behavior of html preview as agreed on ess-help

2013-08-30  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-defaults): added PROCs
	sgdesign and sgrender

2013-08-23  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-interactive): remove '< /dev/tty'

2013-07-27  Henning Redestig  <henning.red@gmail.com>

	* ess-roxy.el (ess-roxy-mode): add interoperability with
	auto-fill-mode

2013-07-15  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-site.el: Here is a workaround for an Emacs bug related to indirect
	buffers and spurious lockfiles that rears its ugly head with .Rd files
http://lists.gnu.org/archive/html/bug-gnu-emacs/2013-02/msg01368.html
http://debbugs.gnu.org/cgi/bugreport.cgi?bug=14328

2013-07-11  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-defaults):  remove annoying 9.3
	note/news from the comment category; it's not a one-time 9.3 specific
	message; it is also in 12.1 and presumably it is now eternally
	annoying; but we can't font-lock it since it changes with every
	new SAS release and it is not worth the maintenance/vigilance

2013-06-12  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-d.el: see discussion in the thread:
	"patch: identing quit statement like run statement in ess-sas" at
	http://article.gmane.org/gmane.emacs.ess.general/7340

2013-06-09  Stephen Eglen  <stephen@gnu.org>

	* ess-julia.el: Checkdoc modifications, and other whitespace
	cleanup.  Many docstrings were missing, so I've made initial
	guesses at what they should be.

	* ess-site.el (ess-etc-directory): Remove * from docstring.
	Fix most points noted by checkdoc.

2013-06-07  Stephen Eglen  <stephen@gnu.org>

	* ess-s-l.el (S-common-cust-alist): Change default for
	comment-use-syntax to t.  Dirk Eddelbuettel reported the follownig
	bug:

	With a line like the following in an R buffer, when M-TAB is hit
	on the line to add a comment, the hash within the string is
	interpeted as an existing comment, causing the string to be
	disrupted.

	rug( foo,  col="#00000030")

	This is now fixed such that M-TAB would add a hash at
	the end of the line, allowing for a comment.

2013-04-11  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-edit-keys-toggle): `sas-indent-line' still
	broken (going on 15 years AFAIK) resulting in futile bug reports
	(and precious little bug-fixing): changing the default to t so
	TAB is bound to `ess-sas-tab-to-tab-stop' by default

2013-04-06  Henning Redestig  <henning.red@gmail.com>

	* ess-s-l.el (ess-smart-S-assign): rename (ess-smart-underscore-*)
	to (ess-smart-S-assign-*) and create aliases to remain compatible.

2013-03-07  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-custom.el/ess-sas-d.el (SAS-mode-hook): creation

2013-03-02  Henning Redestig  <henning.red@gmail.com>

	* ess-s-l.el (ess-insert-S-assign): deleting horizontal space is
	not desirable when using alternative smart underscore like <
	(ess-smart-underscore): customizable smart underscore
	(ess-toggle-underscore): remove key assignments for both the
	default underscore and the potentially modified
	ess-smart-underscore-key

	* ess-custom.el (ess-smart-underscore-key): customizable the smart
	underscore

2012-12-09  Richard Heiberger <rmh@temple.edu>

	* ess-tracebug.el (ess-bp-type-spec-alist): remove unnecessary
	"browser();" call when recover() is used.

2012-10-21  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (mark-paragraph): move function advice activations
	to ess-r-d.el instead so that functions are not advice in all
	modes. This also appears to fix bug reported by Dirk Eddelbuettel.

2012-10-07  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-previous-entry): new behavior, ess-roxy
	uses the prefix string of the current block instead of only the
	prefix specified in ess-roxy-str

2012-10-06  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-hide-all): introduce new ess-roxy-re to
	fontify roxygen blocks that are done with different prefix than
	the actually used prefix

2012-09-29  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-r-args.el (ess-r-object-tooltip): new

2012-09-13  Richard M. Heiberger <rmh@temple.edu>
	* ess-site.el add new customizable variable
	(ess-directory-containing-R) to allow ess-r-versions-created to
	find R exectuables on Windows in directories other than the
	default install location.

2012-09-13  Richard M. Heiberger <rmh@temple.edu>
	* *.el files: uniformly changed my name to "Richard M. Heiberger"
	and uniformly changed my email address to "rmh@temple.edu"

2012-09-06  Sam Steingold  <sds@gnu.org>

	* ess-custom.el (ess-source-directory): Init as per
	http://stat.ethz.ch/R-manual/R-patched/library/base/html/tempfile.html
	from $TMPDIR, $TMP, $TEMP on all platforms.

2012-09-06  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): added PROC SETINIT

2012-08-22  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-rtf-portrait/landscape): bug-fix:
	make new file buffer by adding .rtf; this fixes nagging issue;
	also ess-sas-rtf-*-landscape replaced by ess-sas-rtf-landscape
	on Emacs; but Emacs and XEmacs implementations have diverged;
	XEmacs currently untested, continue using ess-sas-rtf-*-landscape

2012-07-23  Stephen Eglen  <stephen@gnu.org>

	* ess-help.el, ess-r-gui.el, ess-sas.el, ess-sp4-d.el,
	ess-sp6w-d.el, ess-trns.el, essd-els.el: Set `buffer-read-only'
	rather than using toggle-read-only (recommended by byte compiler).

2012-07-02  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-developer.el (ess-developer-add-package): new first
	argument (prefix!) 'from-attached'.  Essential for large list of
	packages on slow (e.g., NFS mounted) file systems.

2012-06-05  Stephen Eglen  <stephen@gnu.org>

	* ess-r-d.el (ess-dirs): Do not set ess-directory.

2012-05-21  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): add an annoying 9.3
	note/news to the comment category

2012-05-15  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-goto): bug-fix; if the root of file name
	contains a suffix, then still goto correctly, e.g. logit.sas
	has log in it

2012-05-12  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-sas-d.el: Set C-c C-w only in SAS (e.g. *not* in R).

2012-05-11  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-rtf-*): XEmacs support returns!
	5.13 era functions are used if (featurep 'xemacs)
	otherwise, 5.14+ Emacs variants

2012-05-10  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess.el (ess-version-string): make robust against wrong/empty SVN-REVISION

2012-05-07  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-rd.el (Rd-mode): set ess-language "S" and ess-dialect "R", so
	R may be autostarted, when desired.

2012-05-06  Sam Steingold  <sds@gnu.org>

	* ess-site.el: Do not quote lambda expressions.
	* noweb-font-lock-mode.el (noweb-font-lock-fontify-chunk-by-number):
	Use `syntax-begin-function' when available instead of
	`font-lock-beginning-of-syntax-function' (obsolete in Emacs 23.3).
	Avoid `progn' in `cond' and some other minor code cleanup.

2012-05-05  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-custom.el (inferior-STA-program-name): is now "stata" as it
	should be and not "env" + all the support modifications.

	* ess-sta-l.el (ess-help-STA-sec-keys-alist): corrections and
	additions to sections keys and regular expressions for STATA.

	* ess-s-l.el (S-common-cust-alist)
	* ess-sta-d.el (ess--STA-retrive-topics-from-search)
	(ess-get-STA-help-topics): customizable topic retrieval. Stata has
	same interactive facilities as R.

	* ess-custom.el (inferior-STA-args): customizable stata arguments.
	(inferior-STA-program-name): program name is "stat" as it should
	be (and not "env").

2012-05-02  Sam Steingold  <sds@gnu.org>

	* ess-r-args.el (tooltip-show-at-point): Do not use the assoc
	package (which is obsoleted by Emacs 24.2 anyway), use let
	instead, it is cleaner and more reliable.


2012-04-23  Vitalie Spinu  <spinuvit@gmail.com>

	* merged Daniel Hackney's changes
	Squashed commit of the following:

	commit 708101bef3e5c1f20f53736a9e93799eddaf4f0c
	Author: Daniel Hackney <dan@haxney.org>
	Date:   Mon Apr 23 00:28:53 2012 -0400

        Remove incorrect description of the GPL

        A couple files had the following in their header:

        In short: you may use this code any way you like, as long as you
        don't charge money for it, remove this notice, or hold anyone liable
        for its results.

        This is not an accurate description of the GPL, and should therefore not appear
        in the headers.

	commit c93848d930783f0c38fec1ff07af40fb623799d1
	Author: Daniel Hackney <dan@haxney.org>
	Date:   Sun Apr 22 23:03:42 2012 -0400

        Clean up all whitespace according to settings from ".dir-locals.el"

        Uses `whitespace-cleanup' to set a consistent style for whitespace throughout
        the project. This can be applied with:


        (defun recursive-files (dir func)
          (loop with before-save-hook
                for (file is-dir)
                in (directory-files-and-attributes dir t ".*\.el$")
                if is-dir
                do (recursive-files file form)
                else
                do (with-current-buffer (find-file-noselect file)
        	     (apply func)
        	     (basic-save-buffer)
        	     (kill-buffer))))

        (recursive-files 'whitespace-cleanup)

        Again, this can be run from "emacs -Q" after "(require 'cl)"

	commit 3c9c0857d67bda1e9161e37ed426e97a8c61223c
	Author: Daniel Hackney <dan@haxney.org>
	Date:   Sun Apr 22 22:51:54 2012 -0400

        Directory-local variables for whitespace cleanup.

        Use the `whitespace' library for the cleaning.

	commit 8dc3d6db1d40956ab96c33b18a80a95a047b46b3
	Author: Daniel Hackney <dan@haxney.org>
	Date:   Sun Apr 22 22:40:28 2012 -0400

        Convert files to `utf-8-unix' coding system.

        The default coding system to use going forward, `utf-8-unix', is set as a
        directory-local variable in ".dir-locals.el".

        To force all elisp files to use the `utf-8-unix' coding system, the following
        code will recursively walk through all elisp files in the specified directory
        set the encoding system, and save the file.

        (require 'cl)

        (defun recursive-files (dir func)
        (loop with before-save-hook
        for (file is-dir)
        in (directory-files-and-attributes dir t ".*\.el$")
        if is-dir
        do (recursive-files file form)
        else
        do (with-current-buffer (find-file-noselect file)
        (apply func)
        (basic-save-buffer)
        (kill-buffer))))

        This can be invoked as follows:

        (recursive-files "/path/to/ess" '(lambda () (set-buffer-file-coding-system 'utf-8-unix)))

        To ensure no other variables from the user environment impact the process, this
        code can be run in "emacs -Q", which doesn't load any startup files (outside of
        the emacs core).

        This function could perhaps be split out, named better, and put in its own file.

	commit 6352290fe13ce9048abaa0e401679a67bbcafe43
	Author: Daniel Hackney <dan@haxney.org>
	Date:   Tue Apr 17 21:01:36 2012 -0400

        Reformat all headers to be consistent.

        Summary of changes made:

        * Correct first- and last-line format. Preferred is three semicolons, file name,
        either three dashes and the description (first line) or the string "ends
        here" (last line).

        * Changed header comment lines to match conventions. "Author" and "Maintainer"
        headers are singular, even when there are multiple authors or maintainers.

        * Use the correct number of semicolons for each header section. Regular comments
        should have two semicolons; section headers, such as "Commentary" or "Code"
        should have three.

        * Fixed "Keywords" header comments. There is a standard-ish set of keywords used
        in Emacs, available through `finder-by-keyword'; this commit uses those
        conventions. Also, keywords are now separated by comma then space and do not
        have a trailing period.

        * Trailing newline at end of file. A few files lacked this, which makes
        subsequent diffs which modify the last line unnecessarily noisy.

        * Moved "Code" section marker before any and all code in a file.


2012-04-21  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess.el (ess-version-string): new, and (ess-version) uses it.

2012-04-12  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-s-l.el (ess-use-this-dir): add 'no-force-current, and switch
	default to *try* finding a current *R* buffer.

2012-04-11  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-d.el (ess-bugs-mode):
	* ess-jags-d.el (ess-jags-mode):
	   (setq ess-language "S") ; mimic S for ess-smart-underscore

2012-04-05  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-custom.el (ess-revision): extraordinary attempts
	to get revision number

2012-04-03  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-force-buffer-current): use no-autostart, instead
	of autostart (each with the emacs default of nil).  This
	re-instantiates ESS 5.x behavior.

2012-04-03  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-custom.el (ess-first-tab-never-completes-p): defalias for
	ess-first-tab-never-complete
	(ess-first-tab-never-complete): plenty of options for every taste.
	(ess-tab-complete-in-script): new option.

2012-04-02  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-mode.el (ess-mode): try hard to find an alist if not suplied

	* ess-utils.el (ess-inside-string-or-comment-p)
	(ess-inside-string-p): rewrote this facilities to take advantage
	of font-lock

	* ess-julia.el (julia-customize-alist)
	(julia-get-help-topics-list-function)
	(julia-send-string-function, julia)
	(julia-imenu-generic-expression): ess-julia.el

2012-04-01  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-mode.el (ess-error-regexp): custom error messages for dialects

2012-04-02  Sam Steingold  <sds@gnu.org>

	* ess-help.el (ess-help-mode-map): Older XEmacs misses
	`special-mode-map', check for that.
	* ess-tracebug.el (ess-watch-mode-map): Likewise.

2012-04-02  Sam Steingold  <sds@gnu.org>

	* ess-tracebug.el (ess-bp-kill): Bug fix: `called-interactively-p'
	requires an argument; fix it as recommended in the doc for
	`called-interactively-p' by avoiding it altogether; this also
	takes care of compatibility.

2012-04-02  Sam Steingold  <sds@gnu.org>

	* ess-help.el (ess-help-mode-map): All supported emacsen have
	`set-keymap-parent'.
	* ess-inf.el (inferior-ess-mode-map, ess-mode-minibuffer-map): Likewise.
	* ess-tracebug.el (ess-watch-mode-map): Likewise.
	* ess-trns.el (ess-transcript-mode-map): Likewise.
	* ess-mode.el (ess-mode-map): Likewise.

2012-04-02  Sam Steingold  <sds@gnu.org>

	* ess-inf.el (update-ess-process-name-list, ess-cleanup):
	Use `dolist' instead of `mapc'+`lambda' for clarity and speed.
	* ess-help.el (ess-help-mode, ess-describe-sec-map)
	(ess-get-help-files-list, ess-get-help-aliases-list): Likewise.

2012-04-02  Sam Steingold  <sds@gnu.org>

	* ess-custom.el, ess-custom.el, ess-mous.el, ess-mouse.el:
	* ess-r-args.el, ess-r-d.el, ess-rd.el, ess-s-l.el, ess-s4-d.el:
	* ess-site.el, ess-sp5-d.el, ess-sp6-d.el, ess-swv.el:
	* ess-tracebug.el, ess-utils.el, ess.el, make-regexp.el, mouseme.el:
	* noweb-mode.el: Do not quote lambda forms, this is never needed.

2012-04-02  Sam Steingold  <sds@gnu.org>

	* ess-site.el: Rise up to the challenge: use `locate-file'
	instead of horrible adhockery to check if info can find ess.info.


2012-03-30  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-custom.el (ess-arg-function-offset-new-line): If a list of
	the form '(N), indent at the indentation + N

	* ess-r-d.el (ess-R-get-rcompletions, ess--funargs-command):
	workaround for enableJIT warnings for R > 2.14.2

2012-03-26  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-help.el (ess-skip-to-help-section): this issue is documented in 2 places
http://www.xemacs.org/About/XEmacsVsGNUemacs.html
http://www.xemacs.org/Documentation/21.5/html/cl_4.html
So, the schism goes back many years: circa 1997-1998.  The fix is simple.
If the keypress is meant to be a character, then
you wrap last-command-event as follows...

(if (featurep 'xemacs) last-command-char last-command-event)

2012-03-25  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (ess-get-object-list): new arg exclude-first to allow
	exclusion of objects from .GlobalEnv in help completion.

2012-03-21  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (ess--funargs-command): "error" option is reset to
	NULL in critical completion and eldoc actions.

	* ess-inf.el (inferior-ess-set-status): new argument no-timestamp
	to allow ess-command not to set the timestamp.

2012-03-20  Vitalie Spinu  <spinuvit@gmail.com>

	* noweb-mode.el (noweb-minor-mode-map): adjusted [tab] and
	[return] keys not to interfere with ac-mode

2012-03-19  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (ess-eldoc-docstring-format): smart for-mating of a
	doc string in minibuffer.

	* ess-custom.el (ess-eldoc-abbreviation-style): level to filter/truncate
	the doc string.

2012-03-16  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (ess--funname.start): is limiting the search from the
	process marker only (bug reported by Sam Steingold on Mon Mar 12
	19:40:22 CET 2012)

	* ess-inf.el (ess-object-completion, ess-complete-object-name):
	give suggestive info if proc is not associated.
	(ess-filename-completion): :exclusive 'no
	(inferior-ess-mode): completely removed dependence on
	comint-dynamic-complete.

	* ess-r-d.el (ess-R-complete-object-name): added info message on
	missing proc.

	* ess-roxy.el: (ess-roxy-tag-completion): new completion function
	for emacs 24
	(ess-roxy-mode): adjusted roxy tag completion to new ESS and emacs
	24 system.

2012-03-14  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-complete-tag): removed function advice for
	(ess-internal-complete-object-name) to reflect the new tab
	behavior and also made tab not hide roxy entry unless point is at
	the beginning of the line (so similar to org-mode's visibility
	cycling)
	(comint-dynamic-complete-functions): and dropped the advice
	to (ess-R-complete-object-name) as well.


2012-03-13  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-preview): put all R-code on one line to
	get rid f the +s


2012-03-13  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (inferior-ess-mode-map): don't bind M-TAB in emacs 24.

	* ess-mode.el (ess-mode-map): Don't bind M-TAB  in emacs 24, it's
	the emacs standard to call completion-at-point or comlete-symbol
	which do the same thing.

	* ess-r-d.el (ess-R-get-rcompletions): return a token as a first
	element of a list.
	(R-mode): init emacs 24 completions.

2012-03-12  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (ess-filename-completion): filename completion to
	comply with emacs 24 standard.
	(ess-complete-filename): modified quote detection.

2012-03-11  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-preview): semi-working version for
	roxygen2 without creating directories. Unfortunately appends lots
	'+'s at the created Rd file.

2012-03-09  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-help.el (ess-help-kill, ess-help-quit): smarter quit and
	kill behavior.
	(ess-display-help-on-object): fixed the help display bug.

2012-03-08  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-custom.el (ess-arg-function-offset-new-line): new
	indentation offset, better handling of long funargs. See the doc.

2012-03-05  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-custom.el (ess-first-tab-never-completes-p): if t never
	complete on first TAB in ess-mode.

	* ess-mode.el (ess-indent-or-complete): improved handling of the
	nil process

	* ess-s-l.el: removed S-calculate-indent and S-indent-line (these
	are ess-indent-line and ess-calculate-indent from 2004 already,
	and created confusion)

2012-03-04  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-swv.el (ess-swv-PDF): ess-completing-read

	* noweb-mode.el (noweb-goto-chunk): ess-completing-read

	* ess-inf.el (ess-request-a-process, ess-request-a-process)
	(ess-read-object-name): ess-completing-read

	* ess-tracebug.el (ess-dbg-command-digit): ess-completing-read

	* ess-rd.el (Rd-mode-insert-section): ess-completing-read

	* ess-mode.el (ess-set-style): ess-completing-read

2012-03-02  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-custom.el (ess-roxy-package): new variable, (FIXME potentially)
	with new default "roxygen2". %% FIXME, 'roxygen2' fails
	* ess-roxy.el (ess-roxy-preview): now using ess-roxy-package
	instead of "roxygen".

2012-03-02  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-l.el (ess-bugs-hot-arrow): add a space before arrow

2012-03-01  Vitalie Spinu  <spinuvit@gmail.com>

	* ess.el (ess-yank-cleaned-commands, ess-yank): C-u C-u C-y yanks
	only the commands from the kill ring (as proposed by Richard
	M. Heiberger). It uses ess-transcript-clean-region.

2012-02-29  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-mode.el (ess-mode): use comint-dynamic-completion.

	* ess-r-d.el (R-mode): use comint-dynamic-completion.

	* ess-mode.el (ess-mode-map): TAB is bound to ess-indent-or-complete.

2012-02-27  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (ess-function-arguments): works with current instead
	of local process. That means eldoc and completion are available
	even if buffer is not associated with a process.

	* ess-help.el (ess-help-bogus-buffer-p): regexp includes the name
	of the doc object.
	(ess-display-help-on-object): killed buffer display bug fix,
	reported and fixed by Sam Steingold.

	(ess-help-mode-map): inherits form special-mode-map, "k" is
	kill-this-buffer instead of kill-buffer. "q" is quit-window
	instead of bury-buffer. (pointed by Sam Steingold)

	* ess-r-d.el (ess-funname.start, ess-function-arguments):
	execution bugs corrected and robustified  caching.

	* ess-r-args.el (ess-r-args-get): relies on ess-function-arguments now.

	* ess.el (ess-load-extras): new function to load extra features.

	* ess-tracebug.el (ess-tracebug-map): a couple of renames.

	* ess-mode.el (ess-mode): (ess-load-extras)

	* ess-eldoc.el (ess-eldoc): moved the code into ess-r-mode.el.

	* ess-developer.el: moved documentation into the user manual

	* ess-custom.el (ess-use-eldoc, ess-eldoc-show-on-symbol)
	(ess-use-auto-complete): Implemented ess-use-xxx system.

2012-02-26  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-tracebug.el (ess-tracebug-prefix): set to nil, as to require
	the user to choose the binging.

2012-02-25  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-tracebug.el (ess-long+replacement): it's shorter "+ . +" now.

	* ess-custom.el (inferior-ess-S-prompt): small adjustment of the
	prompt for tracebug cuts.

	* ess-r-d.el (ess-function-arguments): modified the form of the
	returned value.

2012-02-23  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el:
	(ess-switch-to-ESS): force-buffer-current instead of
	make-buffer-current. Much more useful in interactive use, which
	this function is almost always used.
	(ess-force-buffer-current): New argument to auto-start process if
	the process died. This case was not treated before.

2012-02-21  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-eldoc.el (ess-eldoc-everywhere-p): controls whether to show
	args everywhere or only inside function call.
	(ess-eldoc): complete rewrite of ess-eldoc, to use argument
	completion api. Automatic caching + generic args + handling of
	complex expressions + calling process only when really needed.

	* ess-r-d.el (ess-function-arguments): optimized funarg retrieval.
	(ess-get-object-at-point): a very permissive version of
	symbol-at-point. Allows almost any R object.

2012-02-20  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (inferior-ess-set-status): set 'last-eval property
	giving the time of the last interaction with the process.

	* ess-r-d.el (ess--funargs-cache, ess-function-arguments): New
	uniform caching support for argument completion. Arg are reliably
	cached on first completion invocation. All completion mechanisms
	should use ess-function-arguments.
	(ess-funname.point): Retrieve the name of a function call and
	starting point of a call. All interfaces should use it for
	argument completion.

	* ess-r-args.el (ess-r-args-get): completes arguments for S3
	generic if found.

	* ess-r-d.el (ac-source-R, ac-source-R-objects)
	(ac-source-R-args): Completely rewrote the ac support. ESS now
	provides the above 3 sources to accomplish any completion taste.

2012-02-19  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (ess-switch-to-ESS): Associates the buffer with
	current process. Make sense when the buffer is not yet associated
	with any process.
	(with-current-process-buffer): new macro to execute the &body
	inside current ess process buffer.
	(ess-command): removed PROMPT argument.
	(ess-command): removed sleeping, not relevant anymore argument
	still stays, apparently needed for dde.

2012-02-04  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-tracebug.el (ess-watch-mode): corrected watch-mode
	documentation and added the ? and d keys.

2012-02-03  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (inferior-ess--get-old-input:regexp): silent
	byte-compile on free var.

	* ess-tracebug.el (ess-tracebug-inject-source-p): better control
	source injection.
	(ess-eval-region2): removed eva-region, eva-linewise,
	eval-function fixes from tracebug (everything incorporated into
	the core).

	* ess-inf.el (ess-eval-function): complete rewrite to accommodate
	developer and tracebug and potentially other addons in the future.
	(ess-load-file) calls ess-tracebug-source-current-file if tb is
	active.

	* ess-developer.el: Many unifying changes, bug fixes. Follows
	ess-eval-visibly-p whenever possible. Implemented region and
	function devEvals.

	* ess-inf.el (ess-eval-region): moved ddeclient to lower level
	`ess-send-region'
	(ess-send-string, ess-send-region): consolidated these low-level
	work-horse functions.

2012-02-02  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (ess-eval-region): removed the archaic
	ess-synchronize-evals, a workaround for emacs 18.57.
	(ess-eval-region): is now aware of ess-tracebug and ess-developer.

2012-02-01  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (ess-sos, ess-setRepositories, ess-setCRANMiror): added two more handy
	commands.

	* ess-roxy.el (ess-roxy-mode-map): new key C-c C-e t for preview-text
	(ess-roxyb-preview-text): new function for preview in text format

	* ess-rd.el (Rd-preview-help): solved nil file-name bug with roxy
	preview.

2012-01-28  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-developer.el (ess-developer-assign-function): integrated
	with ess-eval-function; also takes care of tracebug.

	* ess-tracebug.el (ess-tracebug-assign-function): tracebug doesn't
	reassign ess-eval-function anymore (it's integrated now in ESS)
	(ess-process-send-string): moved into ess-inf.el

	* ess-inf.el (ess-process-send-string): low level wrapper for
	process-send to enable pre-processing of input string. Currently
	removes empty lines when debugging is active.

	* ess-inf.el (ess-load-file): if in developer mode call
	ess-developer-source-current-file.
	(ess-process-get): new function,  wrapper for process-get
	(ess-eval-function): is now aware of ess-developer and ess-tracebug
	(ess-command): added two new arguments wait and prompt

2012-01-27  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-tracebug.el (ess-dbg-mode-line-indicator): dynamic mode line
	support.

	* ess-custom.el (ess-mode-line-indicator): doc string

	* ess-tracebug.el (ess-dbg-flag-for-debugging): added support for
	org mode and file free buffers.

2012-01-23  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (ess-library): set ess-sp-change to t.

	* ess-inf.el (ess-smart-comma): made smart operators
	customizable. New ess-smart-variables local var to hold smart ops
	which are active in the mode.

	* ess-r-d.el: further work on AC.

	* ess-custom.el (inferior-ess-S-prompt): small adjustment of S prompt regexp.

2012-01-21  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-tracebug.el : several corrections to silent the compiler.

	* Makefile (ELC): added developer and tracebug.

	* ess-r-d.el (ac-source-R-objects, ac-source-R-args): two sources for ac.
	(ess-init-ac): default initialization of ac.

	* ess.el (ess-completing-read): added automatic handling of ': '.

	* ess-tracebug.el (ess-dbg-flag-for-debugging)
	(ess-dbg-unflag-for-debugging): modiefied to use ess-completing-read.
	(require): removed ido dependency.


2012-01-20  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-d.el (ess-bugs-font-lock-keywords): add
	censoring notation: C( , )

2012-01-20  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (inferior-ess--goto-input-start:regexp): new function
	for regexp based input search.
	(inferior-ess-get-old-input): ESS now fully supports both field
	and regexp input handling. Fields are not used though; may be in
	the future.
	(inferior-ess-mode): removed ac inits
	(ess-mode): removed ac inits  (was too intrusive)

	* ess-custom.el (inferior-ess-S-prompt): new custom var. User can
	customize this regexp to enhance navigation in comint and
	transcript buffers.

2012-01-19  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (ess-R-get-rcompletions): require 'ess-tracebug

	* ess-tracebug.el Added and integrated with ESS.

	* ess-inf.el (inferior-ess-set-status): returns the process busy
	status for convenience

2012-01-18  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): generalized
	support for NOTEs/WARNINGs/ERRORs with numeric
	call signs that match the regexp [0-9]+-[0-9]+

2012-01-18  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-mode.el (ess-mode): added ac support

	* ess-inf.el (inferior-ess-mode): added ac support

	* ess-r-d.el (R): added ac support

	* ess-custom.el (ess-use-ac-p, ess-ac-source-R)
	(ess-ac-sources-R, ess-ac-source): added auto-complete integration.

	* ess-r-d.el (ess-R-complete-object-name): simplified
	ess-R-complete-object-name by reducing huge number of invocations
	of ess-command to 2
	(ess-R-get-rcompletions): new function - workhorse of internal
	r-completions.

	* ess-r-args.el (ess-r-args-get): new TRIM argument
	(ess-r-args-show): rearrangement of the code.

	* ess-eldoc.el (ess-eldoc): moved new-line replacement into
	ess-r-args-get.

2012-01-17  Vitalie Spinu  <spinuvit@gmail.com>

	* ess.el: added xemacs support for process-plist,
	set-process-plist, process-put and process-get.  All should be
	removed when xemacs finally supports them.

	* ess-site.el: removed the piece on customizing prompts, it does
	not work and is misleading for the users.

	* ess-r-d.el (R): write proc version into dribble.

	* ess-inf.el (ess-multi): marking newly created ess process as
	busy and wait for the proc afterward.

2012-01-16  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-trns.el (ess-transcript-mode): small adjustment of the prompt.

	* ess-inf.el (inferior-ess-get-old-input): supports both fields
	and regexp comint and acts in accordance with the value of
	'comint-use-prompt-regexp.
	(ess-smart-comma): improved usability.

	* ess-custom.el (ess-handy-commands): improved handy commands for
	smart comma.

	* ess-trns.el (ess-transcript-mode): set comint-use-prompt-regexp
	to t in trns-mode and adjusted regexp of the inferior-ess-prompt.

2012-01-15  Vitalie Spinu  <spinuvit@gmail.com>

	Major re-factoring of ess-inf.el - new waiting-for-prompt mechanism.

	* ess-inf.el (ordinary-insertion-filter): complete cleanup.
	(inferior-ess-output-filter): sets process status (i.e. busy,
	sec-prompt properties)

	* ess-inf.el (ess-multi): removed inferior-ess-wait-for-prompt and
	replaces with ess-wait-for-process which uses new prompt
	monitoring mechanism
	(ess-eval-linewise): removed timeout-ms and replaced with wait-sec
	to be parsed to ess-wait-for-process. Default is 0s. Removed
	kludges and prompt waiting loop.
	(inferior-ess-get-old-input): completely redefined to take
	advantage of fields.
	(inferior-ess-goto-input-end):
	(inferior-ess-goto-input-end): new functions to navigate through
	input by means of fields in inferior-buffer or transcript.

	* ess-custom.el (inferior-ess-primary-prompt): simplified default
	prompts to "> " and "+ "

	* ess-arc-d.el (xxx-customize-alist): replaced deprecated
	comint-use-prompt-regexp-instead-of-fields with
	comint-use-prompt-regexp.

2012-01-14  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (R-customize-alist): removed
	inferior-ess-command-prompt. It is no longer necessary with recent
	changes in the waiting mechanism.


2012-01-14  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-eldoc.el (ess-eldoc): remove new lines from argument list to
	avoid frequent distortion of emacs windows.

2012-01-07  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-mode-map): C-c . sets style (as in C-mode)

2011-12-23  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (ess-smart-comma): inspired by slime-repl ,shortcut.
	If "," is the first character typed in the inferior-ess buffer it
	requests for execution one of the commands in ess-handy-commands
	list.

2011-12-14  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-mode.el (ess-calculate-indent): let bind
	beginning-of-defun-function to nil in ess-calculate-indent to
	prevent the use of ess-beginning-of-function

2011-12-13  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-mode.el (ess-mode): set beginning-of-defun-function and
	end-of-defun-function to make swank/slime work.
	(ess-function-pattern): allowed for function names of the form
	'.+', '.+', ".+" in ess-R-function-pattern.

2011-12-12  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-developer.el (ess-developer): the bulk of ess-developer.el
	and ess-developer.R is finished. See the file header for the full
	details.

2011-12-01  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (ess-library): ido interface to library()

2011-11-24  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (ess-prompt-wait): ess-prompt-wait is more
	sophisticated now. It checks for prompt only if no more output has
	been received from the process. Looking-at is replaced with
	re-search-forward in order to avoid anchoring the prompt to the
	bol.

2011-11-18  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-developer.el (ess-developer-source-current-file):
	interface to insertSource.

	* ess-inf.el (ess-get-process-variable): added (boundedp var)
	check.  If var is not defined ess-get-process-variable returns
	nil. Useful when some vars are defined for one mode and not for
	others.

2011-11-17  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-inf.el (ess-eval-function-or-paragraph-and-step): now calls
	ess-eval-function in order to reuse ess-developer and ess-tracebug
	improvements of ess-eval-function.
	(ess-eval-function): new argument 'no-error


2011-11-14  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-help.el (ess-read-helpobj-name-default): defined alias for
		  ess-helpobj-at-point.

2011-11-13  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-help.el (ess-helpobj-at-point): modified the name of
	ess-read-helpobj-name-default to a more intuitive one and
	consistent with emacs conventions.

	* ess-custom.el (ess-help-pop-to-buffer): If non-nil ess-help
	buffers are given focus during the display.
	(ess-ido-flex-matching): if you don't use ido flex matching but
	still want it for ESS, here it is.

	* ess-help.el (ess-display-help-on-object): put cache update on
	universal argument, it also regenerates the help buffer as
	before. Removed curr-* kludge which was not necessary. Removed the
	handling of help buffer into separate function.
	(ess-help-type): local variable in help files holding the help
	type symbol. So far, 'help, 'index, 'vignette.
	(ess-help-object): local in help files holding the name of the
	help object, i.e. name of the package for index and help topic for
	ordinary help.
	(ess-help-mode-map): new keys - i for index, v for vignette, w for
	help in web-browser. "q" key is not burring the buffer instead of
	jumping to the end of ESS. C-c C-z is standard combination for
	that action.
	(ess-help-mode-menu): new menu entries for index vignette and
	browse in web-browser.
	(ess-find-help-file): This one does not do the prompt processing
	anymore. Everything is done in ess-completing-read now.
	(ess-get-help-topics-list): topics are now list of strings instead
	of alist. IDO and emacs handles them better. A workaround is
	implemented for Xemacs to use alist in ess-completing-read.
	-------------
	New functions:
	(ess-display-index): linked index with ido request.
	(ess-R-display-vignettes, ess-display-vignettes): display
	vignettes in nicely formatted, linked help buffer. In xemacs emits
	the call to browseVignettes() instead.
	(ess-display-help-in-browser): pop the current help page in
	browser.
	(ess--switch-to-help-buffer): display help buffers, consistently
	with `ess-help-pop-to-buffer' and `ess-help-own-frame'.

	* ess.el (ess-completing-read): moved code around.

	* ess-inf.el (ess-eval-function): integrated ess-developer in ess-eval-function
	Works only for R, useful for S as well?

	* ess-mode.el (ess-mode): integrated mode-line-indicator.

	* ess-inf.el (inferior-ess-mode): integrated mode-line-indicator.

	* ess-custom.el (ess-mode-line-indicator): added dynamic mode-line
	indicator. Mode line of ess-mode is now in sync with the
	associated process. This feature is used by ess-developer and
	ess-tracebug.  Xemacs does not have the necessary support for it.

2011-11-12  Vitalie Spinu  <spinuvit@gmail.com>


	* ess.el (ess-completing-read): new function to use for completion
	in ESS. It uses ido completion mechanism whenever available, and
	falls back on classical completing-read  otherwise.

	* ess-r-d.el (ess-install.packages): fast way to instal packages
	with ido interface.

	* ess-custom.el (ess-use-ido): users can disable ido if they
	don't want it.
	(ess--completing-hist): new internal variable to store completion
	history.

	* ess-inf.el (ess-get-words-from-vector): addapted regular
	expression to match "\"", this was breaking the command
	before. See etc/R-ESS-bugs.el (bug 1).

	Added comment on max.print truncating the vector in the
	doc string (bug 2 in etc/R-ESS-bugs.el). Sill not sure if
	should wrap the code automatically or leave it to the user.

2011-11-11  Vitalie Spinu  <spinuvit@gmail.com>

	* ess-r-d.el (R-customize-alist): added
	`inferior-ess-command-prompt' to R-customize-alist. Solves bug 3
	in etc/R-ESS-bugs.el.

	* ess-custom.el (inferior-ess-command-prompt): new prompt regexp
	to be used specifically in ess-command. If nil (the default)
	ess-command uses `inferior-ess-primary-prompt' as it was before.

	* ess-inf.el (ess-command): Anchoring the prompt to the end of
	buffer in order to avoid premature prompt detection (see
	etc/R-ESS-bugs.el bug 4). Moved ..ok{ess-command} inside
	unwind-protect. Before it was ..ok even when ess-command failed.
	(ess-prompt-wait): Added new required parameter PROMPT-REG for the
	local prompt regexp to be passed explicitly. Before, it was using
	global value of the prompt regexp.
	Dropped start-of-output argument. It's never used in ess-code and
	had confusing meaning wich was not even documented.

2011-11-03  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (sas-fix-life-tables): if read-only,
	then toggle to read-write first
	(SAS-listing-mode): name ESS[LST] for emacs functionality
	that cares about names like tabbar

2011-09-30  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-graph-view): search for GSASFILE more
	robust to handle recent versions of SAS and embedded dots in
	filename

2011-09-17  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-fill-field): Filling text inside roxygen
	entries now operate on individual paragraphs instead of the whole
	field.

2011-09-16  Sebastian P. Luque  <spluque@gmail.com>

	* ess-swv.el (ess-swv-remove-TeX-commands): Simplify removal of
	commands from TeX-command-list (AUCTeX users).  Thanks to Stephen.
	(ess-swv-toggle-plug-into-AUCTeX): Fixed doc string.

2011-09-11  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-update-entry): fixes problem with roxy
	entries in the beginning of a file

2011-09-03  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-in-header-p): fix introduced bug in update-entry

2011-09-01  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-get-args-list-from-entry): couldnt really
	handle the ... argument param description before. can now.

2011-09-01  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-custom.el (ess-history-file): now three-valued;
	(nil, t, <string>). If nil, *no* history is read or written.

	* ess-inf.el (inferior-ess, ess-multi): ess-history-file changes;
	finally *use* the ess-history-directory.

2011-08-31  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-end-of-field): attempt to handle mutiple
	paragraphs inside @param fields etc.

2011-08-31  Sebastian P. Luque  <spluque@gmail.com>

	* ess-help.el (ess-get-help-aliases-list): Choose whether to use
	.readRDS() or readRDS() based on R version.

2011-08-30  Sebastian P. Luque  <spluque@gmail.com>

	* ess-swv.el (ess-swv-plug-into-AUCTeX): Evaluate this function
	after loading tex.

2011-08-18  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-d.el (ess-bugs-switch-to-suffix): let's not
	magnify burn-in (via the thinning multiple)

2011-08-17  Stephen Eglen  <stephen@gnu.org>

	* ess-r-d.el (ess-r-versions): Add "R32" and "R64" if working on a
	mac.

2011-07-28  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-d.el (ess-bugs-switch-to-suffix): complete
	support for thinning:  ESS[BUGS] appears to be ready
	for release

2011-07-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-s-l.el (ess-insert-S-assign): factored out from
	ess-smart-underscore; now also assigned to A-- for *-MM-keys.


2011-07-22  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-d.el (ess-bugs-na-bmd): workaround the
	OpenBUGS nohup bug with "at"; this time without
	creating additional files, i.e. piping to "at"

2011-07-20  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-cd): attempt to workaround Emacs bug; shell
	buffer snarfing the cd command.

	* ess-bugs-d.el (ess-bugs-na-bmd): ditto

2011-07-08  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-d.el (ess-bugs-font-lock-keywords): adding
	keywords that are members of both the OpenBUGS script
	language and BRUGS (why the 2 sets are not the
	same; I don't know)

2011-07-05  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-d.el (ess-bugs-na-bmd): workaround the
	OpenBUGS nohup bug with "at"

2011-06-24  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-jags-d.el (ess-jags-na-jmd): we now support bash

2011-06-23  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-l.el (ess-bugs-next-action): separation of
	ESS[BUGS] and ESS[JAGS] is now functional.  ESS[JAGS]
	is pretty complete, but ESS[BUGS] is still in development,
	however, it does appear to work.

2011-06-22  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-bugs-d.el (ess-bugs-font-lock-keywords): updating to
	new OpenBUGS scripting language (incomplete so far, but
	serviceable)

2011-06-21  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-rtf-replace-chars): fixing form feed bug

	* ess-bugs-d.el/ess-custom.el/ess-compat.el:
	fix a bunch of bugs and get ESS[BUGS] working for GNU Emacs
	utilize (ess-sleep) after (shell) which, apparently, is
	necessary for GNU Emacs; rename ess-sleep-for to
	ess-sleep-for-shell and move to ess-custom

2011-06-20  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-get-function-args): Enhancement to handle
	in-definition comments per Tengfei Yin's request

2011-06-14  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-utils.el (ess-revert-wisely): stores
	and restores the point after revert

2011-06-07  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-log-mode): change
	mode-name to ESS[LOG] so that tabbar-mode
	knows to list the .log's separately from
	the .sas buffers

2011-05-31  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (sas-fix-life-tables): re-implemented
	with re-search-forward/replace-match
	(fix-page-breaks): re-implemented
	with re-search-forward/replace-match; unfortunately,
	not really sure what this function is meant to do;
	probably not very useful to anyone at this point, but
	it does compile without any warnings!

2011-05-27  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el: re-implemented rudimentary RTF support since
	GNU Emacs does not work with rtf-support.el (sadly, XEmacs
	has had this for over a decade); does NOT support font re-sizing;
	you are stuck with a point size of 8.  Enjoy!

2011-05-26  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-eval-paragraph-and-step): Apply Erik Iverson's
	patch from Feb 2011, so that after evaluating the paragraph, it
	skips any blank lines and comments, just like
	ess-eval-line-and-step.
	(ess-eval-function-or-paragraph-and-step): As above.

2011-05-08  Sebastian P. Luque  <spluque@gmail.com>

	* ess-inf.el (ess-show-buffer): Fixed minor typo in doc string.

2011-05-05  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el: several changes necessary to
	support GNU Emacs for ESS[SAS] batch

2011-04-06  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): most
	common SAS/Graph statements now added

2011-04-01  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): adding
	a few common SAS/Graph statements, but much more is
	left to be done

2011-03-25  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (sas-fix-life-tables): I assume that sed
	command worked for someone at some point, but it was not
	working for me; and it was overly complicated, so I
	simplified; hopefully it works now; please test.

2011-03-02  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el: Standardized function names for consistency.
	Thanks to Cesar Rabak (ESS-help).

2011-02-28  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-site.el, ess-bugs-l.el, ess-bugs-d.el, ess-jags-d.el:
	Batch BUGS is back!  With OpenBUGS, a batch BUGS script is
	available for Linux.  Therefore, since it seems that BUGS
	and JAGS must co-exist (rather than a transition from BUGS
	to JAGS), .bug files are in ESS[BUGS] mode and .jug files
	are in ESS[JAGS] mode.  ESS[BUGS] now works like ESS[JAGS]
	rather than the orignal mode ESS[BUGS] mode which was
	difficult to maintain.  However, ESS[BUGS] needs a lot of
	work such as support for thinning, multiple data files,
	etc.

2011-02-14  Sebastian P. Luque  <spluque@gmail.com>

	* ess-swv.el (ess-swv-add-TeX-commands): Use "%t" instead of "%s"
	when Sweave'ing via AUCTeX.

2011-02-13  Sebastian P. Luque  <spluque@gmail.com>

	* ess-custom.el (ess-swv-plug-into-AUCTeX-p): New customizable
	variable, which defaults to nil, to determine whether AUCTeX
	interface is enabled or not.

	* ess-swv.el: New functions to allow working with Sweave via
	AUCTeX.

2011-02-02  Richard M. Heiberger  <rmh@temple.edu>

	* ess-custom.el (ess-program-files, ess-program-files-64)
	(ess-SHOME-versions, ess-SHOME-versions-64)
	(inferior-S+6-program-name, inferior-Sqpe+6-program-name)
	(inferior-Sqpe+6-SHOME-name): Pathnames for all 32-bit and 64-bit
	versions of Sqpe.  Add the most recent "/TIBCO/splus82" and make
	it the default.
	* ess-sp6w-d.el (ess-sqpe-versions-create): Give the function an
	argument of pathnames and an indicator whether they are 32-bit or
	64bit pathnames.
	* ess-site.el (ess-s-versions-created): Use the revised functions
	and variables to find all 32-bit and 64-bit versions of Sqpe.

2011-02-01  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-r-d.el (R): change use-dialog-box (to nil) only on windows.

	* ess-inf.el (ess-get-directory): now use new inferior-R-version
	which is set in the created R-X.Y version functions.

2011-01-31  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el (ess-rterm-version-paths): now use *long* filenames
	* ess-r-d.el (ess-r-versions-create): ditto; now produce "proper"
	version names.
	* ess-r-d.el (ess-rterm-arch-version): extend to return cons; and
	use "-32bit" / "-64bit" in the bi-arch cases.


2011-01-19  Stephen Eglen  <stephen@gnu.org>

	* ess-rd.el (Rd-preview-help): Quote filename to prevent spaces in
	filenames causing problems running the shell-command.
	Fix up so that navigation shortcuts present in normal R Help buffers
	work in the output buffer.
	Add a short docstring and tidy code.

2011-01-12  Richard M. Heiberger  <rmh@temple.edu>

	* ess-site.el (ess-rterm-version-paths): extend to find all 32-bit
	and 64-bit versions of R using both the newer R-2.12.x naming
	convention using the architecture-specific i386 and x64
	subdirectories and the older R-2.11.x naming convention.
	* ess-r-d.el (ess-rterm-arch-version): Isolate this function from within
	ess-r-versions-create to construct an architecture-specific name
	for VERSION, an absolute path to R on Windows.
	* ess-r-d.el (ess-r-versions-create): Remove
	ess-rterm-arch-version into its own function.


2010-12-13  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-request-a-process): Set default to ess-dialect
	rather than ess-language.  Patch from Vitalie S.

2010-11-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-eval-buffer-from-beg-to-here, *-from-here-to-end):
	new functions thanks to Roland Rau, with
	* ess-mode.el (ess-mode-map, ess-mode-menu): key bindings C-c [up]
	/ [down] and corresponding menu entries.

2010-11-25  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-preview): Fixed introduced bug that broke
	preview for functions with empty lines.

2010-11-24  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-get-function-args): fix bug that stopped
	ess-roxy from updating setMethod definitions.

2010-11-23  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-preview): enable preview for all types of
	entries (not only for functions)
	(ess-roxy-toggle-roxy-region): make toggle region operate on the
	visible region instead of the actual start and the
	beginning of the region (behave more like comment-region)

	* ess-mode.el (ess-mode-menu): link to new ess-roxy-preview-HTML
	function in the roxygen menu

	* ess-roxy.el (ess-roxy-preview-HTML): New function that
	generates (and opens) a HTML version of a roxygen entry. Request
	from Kevin Wright.

2010-11-02  Sebastian P. Luque  <spluque@gmail.com>

	* ess-help.el: Do not use (mapcar 'list ...) construct in
	`ess-get-help-files-list', and `ess-get-help-aliases-list', since
	we only need to create lists of lists in `ess-find-help-file',
	where it's needed for useful completion.
	Always return the existing `ess-help-topics-list' list if one
	exists for the current process.

2010-11-01  Sebastian P. Luque  <spluque@gmail.com>

	* ess-help.el (ess-find-help-file): Implemented caching of help
	topics (thanks to Vitalie Spinu).

	* ess-custom.el (ess-help-topics-list): New buffer-local variable
	needed for caching help topics.

2010-10-30  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-rd.el (Rd-section-names, Rd-keywords): "subsection" etc

2010-10-28  Henning Redestig  <henning@psc.riken.jp>

	* ess-custom.el (ess-roxy-tags-param): Vinh Nguyens patch for
	updating the available roxygen tags

2010-10-21  Stephen Eglen  <stephen@gnu.org>

	* ess-site.el (interpreter-mode-alist): Condition upon XEmacs to
	prevent "r" regexp from matching interpreters like "perl".  Bug
	reported by Alex Lancaster.

2010-10-14  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): bringing the
	PROCs up to v. 9.22

2010-09-30  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): many ERROR
	and WARNING messages end in period, period single space or
	period double space (the double space coming from ancient
	typewriter trained typists like myself)

2010-09-21  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-mode.el (ess-electric-brace): fix curly braces
	bug for XEmacs as reported by Joshua Wiley

2010-09-20  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-update-entry): optionally do not fill
	parameter descriptions upon ess-roxy-update-entry.

2010-08-21  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-load-file): Check that tramp-tramp-file-p is
	defined before using.

2010-08-20  Stephen Eglen  <stephen@gnu.org>

	* ess-rdired.el (ess-rdired-objects): R variable names can include
	spaces; handle this case.  Bug report by Sigve Berge Hofland
	<sigve@hofland.no> 2010-08-14.

	* ess-inf.el (ess-load-file): If filename is a tramp-filename,
	preserve just the localname of the file.  Bug report and patch
	provided by Erik Iverson <eriki@ccbr.umn.edu> 2010-08-13.

2010-08-11  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-trns.el (ess-transcript-clean-region): give error (instead of
	"hang") when inferior-ess-prompt is empty.

2010-08-11  Henning Redestig  <henning@psc.riken.jp>

	* ess-custom.el: advice user that no empty lines are allowed in
	description

	* ess-roxy.el (ess-roxy-update-entry): improved documentation

2010-08-10  Henning Redestig  <henning@psc.riken.jp>

	* ess-custom.el (ess-roxy-template-alist): less cryptic default
	for description and details fields

2010-08-06  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-get-function-args): fixed bug: function
	args could not be fetched if 'function' was part of the function
	name

2010-07-29  Sebastian P. Luque  <spluque@gmail.com>

	* Makefile (clean): 4394 Reverted this rule to the previous
	version since it was intended to also clean files with older
	names.  Removed 'ess-rdired.elc' from this rule, since it is
	already in the ELC variable, and "clean" removes those files.
	However, kept the fixed 'ess-xls-d.elc' and 'ess-vst-d.elc' rules.

2010-07-28  Sebastian P. Luque  <spluque@gmail.com>

	* ess-inf.el: 4369 Corrected autoloading of
	`ess-R-complete-object-name' (due to old renaming below).

	* Makefile: 4350 Corrected the "clean" target to account for
	old renaming of essd-* files.

2010-07-12  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-s-l.el (ess-use-this-dir): renamed and moved here: For S and R.
	(ess-mode-hook): bind ess-use-this-dir to M-<RET>

2010-07-05  Stephen Eglen  <stephen@gnu.org>

	* ess-r-d.el (ess-R-use-this-dir): New defun.

2010-07-01  Stephen Eglen  <stephen@gnu.org>

	* ess-eldoc.el (ess-use-eldoc): Use the new R-mode-hook instead of
	ess-mode-hook.

2010-06-26  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-custom.el (R-mode-hook): new, use in
	* ess-site.el: add ess-roxy-mode to R-mode-hook instead of
	ess-mode-hook.

2010-06-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-swv.el: allow customizable "pdflatex" command, via
	* ess-custom.el (ess-swv-pdflatex-commands, ess-sweave): new
	variable, in new group;

2010-06-22  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-complete-filename): Use
	comint-dynamic-complete-filename so that filename is not expanded.

	* ess-r-d.el (ess-R-complete-object-name): If there are no
	possible-completions, should return nil, so that when this
	function is called from comint-dynamic-complete-functions, other
	functions can then be tried.  This should fix bug that history
	expansion was not working (reported by Vinu Jacob).

2010-06-10  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-r-d.el (ess-dirs): give a message, and also set ess-directory.

2010-06-06  Sebastian P. Luque  <spluque@gmail.com>

	* ess-swv.el (ess-swv-PDF): 4308 Fixed cmdstr-*.

	* ess-rutils.el (ess-rutils-updatepkgs): 4352 Use better defaults.

2010-06-03  Sebastian P. Luque  <spluque@gmail.com>

	* ess-help.el (ess-find-help-file): 4318 Replaced `delete-dups' by
	`ess-uniq-list', since XEmacs doesn't know about it.

	* ess-rutils.el: 4345 Redesigned menu generation and key binding
	definitions so that Xemacs understands them.

2010-06-03  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (inferior-ess-mode): Bind M-RET to 'ess-dirs in *R*
	and *S* buffers only.
	* ess-r-d.el (ess-dirs): New function.

2010-05-26  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el (ess-rutils-objs): 4299 Added `fit-frame' (if
	available) after calling rdired.

2010-05-23  Richard M. Heiberger  <rmh@temple.edu>

	* ess-site.el, ess-r-d.el: Detect cases when `R/R-x.y.x' exists and
	`R/R-x.y.z/bin/Rterm.exe' does not exist.  In `ess-find-rterm' in file
	`ess-r-d.el', replace such values with `nil'.  In `ess-site.el',
	use `ess-flatten-list' to remove the `nil'.

2010-05-20  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-a.el (ess-sas-file-path/ess-sas-rtf-portrait):
	creation of portrait RTFs with the ESS[SAS] font sizes
	for non-ESS[SAS]-related buffers, such as .el, now
	allowed, but functionality is somewhat limited
	TODO: ess-sas-rtf-landscape

2010-05-19  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-custom.el (ess-eval-deactivate-mark): The default is true
	since ESS version 5.9, except on XEmacs which doesn't have
	\\[deactivate-mark] and friends

2010-05-18  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-inf.el (ess-eval-linewise): Partially work around a bug
	in GNU Emacs 23.x; thanks to Markus Triska; see
	http://article.gmane.org/gmane.emacs.ess.general/4366

2010-05-18  Stephen Eglen  <stephen@gnu.org>

	* ess-custom.el (ess-own-style-list): New customized variable.
	(ess-add-style): New function, to allow new indentation styles to
	be added.
	Nine indentation variables no longer defcustom, as they are set
	through the `ess-set-style' code, and thus not directly changeable
	by the user via customize.

2010-05-17  Sebastian P. Luque  <spluque@gmail.com>

	* ess-help.el: 4278 `ess-find-help-file' now calls the additional
	function `ess-get-help-aliases-list' so that it offers completion
	on aliases, in addition to object names, removing duplicates.

2010-05-17  Richard M. Heiberger  <rmh@temple.edu>

	* ess-site.el: I added a call to `w32-short-file-name' on each item
	in `ess-rterm-version-path'.  Otherwise Windows can't find files
	with embedded spaces in the directory name.

	I redefined S in Windows.  Now it gives a message to start the S
	GUI from the icon and then connect to it with M-x `S-existing'.
	This applies to M-x S, to the S menu item, and to clicking on the
	icon.

	* ess-sp6w-d.el: turned off a few more `use-dialog-box' and put in
	some more `w32-short-file-name' calls.

2010-05-16  Richard M. Heiberger  <rmh@temple.edu>

	* ess-sp6w-d.el, ess-r-d.el: set `use-dialog-box' to nil for Windows.
	Old version of Windows can't load directories from the dialog.

	* ess-site.el: I revised `ess-rterm-version-path' so it will find
        both 64-bit and 32-bit versions of R on 64-bit Windows.  I tested it
        on 64-bit Windows 7 and 32-bit Windows XP.

	* ess-toolbar.el: add C-c C-c
	`ess-eval-function-or-paragraph-and-step' to `ess-toolbar-items'.
	Started to change spluslogo to splus_icon_small logo (from S-Plus 7 and
	earlier to S+ 8).  This needs an xpm and ppm file and permission
	from TIBCO.  I wrote to Lou Bajuk asking for permission.

2010-05-13  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): we can safely
	assume that any line starting with @ is not a NOTE, ERROR
	or WARNING.  TODO; create separate .sas and .log keywords

2010-05-10  Sebastian P. Luque  <spluque@gmail.com>

	* ess-swv.el (ess-swv-PDF): 4251 Fixed command string for
	`shell-command' to view file.

2010-05-05  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el (ess-font-lock-mode): is alone determining the
	turn-on-font-lock setting in the major modes' hooks.

	* ess-roxy.el (ess-roxy-preview-Rd): more careful checking if
	require(roxygen) works.

2010-05-03  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-inf.el (ess-eval-region): don't call
	deactivate-mark unless it is bound

2010-04-26  Henning Redestig  <henning.red@googlemail.com>

	* ess-roxy.el (ess-roxy-insert-args): do not add param field to
	functions without arguments

	* ess-mode.el (ess-mode-menu): menu entries for editing roxygen
	entries

2010-04-16  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el (ess-rutils-keys): 4298 Turn on by default, now
	that bindings do not interfere with anything.

2010-04-15  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el: 4297 Unconditionally activate submenu Rutils, and
	changed key bindings to avoid using 'C-c c' (reserved for users).

2010-04-14  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el (ess-rutils-htmldocs): 4296 Fixed doc string.

2010-04-13  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el: 4290 Incorporated R function
	.rutils.help.start(), defined in etc/ess-rutils-help-start.R so
	that `ess-rutils-htmldocs' is now fully functional.
	(ess-rutils-rhtml-fn): 4294 Use `expand-file-name' to define path
	to ess-rutils-help-start.R.
	Reintroduced autoloading of ess-rdired.el; we really need it.

2010-04-11  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el: 4271 Provided optional argument REMOTE to
	`ess-rutils-htmldocs', fixed doc strings throughout.

2010-04-10  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-s-l.el (S-indent-line): also consider '#!'; using patch
	from Jeffrey Arnold
	* ess-site.el (interpreter-mode-alist): ditto
	* ess-mode.el (ess-comment-indent): ditto

2010-03-25  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-roxy.el (ess-roxy-get-function-args): also remove tabs

2010-03-24  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): although note
	is a keyword in SAS/GRAPH, it is not used very much, but
	the false positive %put note: ...; is used quite often;
	therefore, the note statement is no longer fontified

2010-03-24  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-roxy.el (ess-roxy-mode): font-lock-add-keywords etc is not
	available and hence not called for XEmacs.

2010-03-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-custom.el (ess-eval-deactivate-mark): change default to t

2010-02-16  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el: 4268 Removed `ess-rutils-chgdir', already
	available as `ess-change-directory' in ess-utils.el, and rebound
	key to that function in menu and optional key bindings.

2010-02-15  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): more statement
	names

2010-02-05  Stephen Eglen  <stephen@gnu.org>

	* ess-custom.el: Tidy up docstrings for defcustom items.
	Asterisk is not used at start of docstring; prefer 'Non-nil means
	...' notation for binary variables.

2010-02-05  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el: 4265 Placed `ess-rutils-keys' under the ess-R
	customization group, not under the inexistent ess-r.

2010-02-05  Henning Redestig  <henning@psc.riken.jp>

	* ess-custom.el (ess-user-full-name): defines the user name which
	is also becomes default for the author field in roxy entries

2010-02-04  Sebastian P. Luque  <spluque@gmail.com>

	* ess-rutils.el: New file

2010-02-03  Rodney Sparapani  <rsparapa@mcw.edu>

	* Makefile (clean): remove more (and hopefully all) legacy .elc files
	* renamed ess-mous.el to ess-mouse.el (renames appear to be complete)

2010-02-02  Henning Redestig  <henning@psc.riken.jp>

	* ess-roxy.el (ess-roxy-update-entry): corrected behavior when
	adding roxygen entries to function with preceeding comments
	* deleted ess-roxygen.el
	* ess-r-d.el removed references to ess-roxygen.el
	* ess-site.el removed references to ess-roxygen.el, replaced with
	ess-roxy.el

2010-02-01  Rodney Sparapani  <rsparapa@mcw.edu>

	* Makefile: add ess-comp.el to dependencies
	for targets with PRELOAD (as it should be)

2010-01-27  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): new
	procedure names for SAS/STAT 9.0/9.1/9.2

2010-01-26  Rodney Sparapani  <rsparapa@mcw.edu>

	* renamed essl-s.el to ess-s-l.el
	* renamed essddr.el to ess-rd.el
	* renamed essd-sp6w.el to ess-sp6w-d.el
	* renamed essd-sp6.el to ess-sp6-d.el
	* renamed essd-sp5.el to ess-sp5-d.el
	* renamed essd-sp4.el to ess-sp4-d.el
	* renamed essd-sp3.el to ess-sp3-d.el
	* renamed essd-s4.el to ess-s4-d.el
	* renamed essd-s3.el to ess-s3-d.el
	* renamed essd-rgui.el to ess-r-gui.el
	* renamed essd-r.el to ess-r-d.el
	* renamed essd-r-args.el to ess-r-args.el
	* renamed essa-r.el to ess-r-a.el
	* renamed ess-cust.el to ess-custom.el
	* renamed ess-emcs.el to ess-compat.el

2010-01-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-roxy.el: new file from Henning Redestig, after moving
	customizations to
	* ess-cust.el: + ess-roxy things

2010-01-20  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-sas-l.el (SAS-mode-font-lock-keywords): add some common
	survival analysis statements to keywords
	(SAS-mode-font-lock-keywords): remove some common false positives
	for 1 and 2 letter SAS statements

	* Makefile (clean): remove old-fashioned names too (see below)

2010-01-18  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-bugs.el renamed to ess-bugs-l.el
	* essd-bugs.el renamed to ess-bugs-d.el
	* essd-jags.el renamed to ess-jags-d.el
	* essl-sas.el renamed to ess-sas-l.el
	* essd-sas.el renamed to ess-sas-d.el
	* essa-sas.el renamed to ess-sas-a.el
	* essl-sta.el renamed to ess-sta-l.el
	* essd-sta.el renamed to ess-sta-d.el

2010-01-18  Stephen Eglen  <stephen@gnu.org>

	* essd-els.el (ess-remote): Use `ess-current-process-name' as the
	local process name if none passed to ess-remote.

2010-01-18  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-utils.el: drop (ess-chop1)

	* essd-r.el (ess-r-versions-create): no longer use ess-chop1

2009-12-07  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-ddeclient-p): fix blunder; add
	(ess-force-buffer-current) for now.

2009-12-04  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-load-file): use microsoft-p instead of
	(ess-ddeclient-p) as that fails to start R automagically.

2009-12-01  Rodney Sparapani  <rsparapa@mcw.edu>

	* essa-sas.el (ess-sas-graph-view-viewer-default): kodakimg
	went the way of the dodo

2009-11-30  Rodney Sparapani  <rsparapa@mcw.edu>

	* essa-sas.el (ess-sas-rtf-portrait): oops, 11 is
	too big, but 10.5 is just right; also, refresh the
	file before making an RTF out of it

2009-10-28  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el (ess-microsoft-p): add 'help_type = "text"' to
	post-run-hook in the microsoft case.

2009-10-26  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (inferior-ess-r-help-command): use .help.ESS() now

	* essd-r.el (R): define .help.ESS(), R-version dependently

2009-10-09  Rodney Sparapani  <rsparapa@mcw.edu>

	* essa-sas.el (ess-sas-rtf-portrait): boost portrait font
	point size to 11

2009-10-07  Rodney Sparapani  <rsparapa@mcw.edu>

	* essa-sas.el (ess-sas-rtf-font-name): now you can
	specify the font that MS RTF are created with; previously,
	these were created with courier, however, this font is
	thin and hard to read with MS Office and OpenOffice

2009-10-06  Stephen Eglen  <stephen@gnu.org>

	* ess-cust.el (inferior-ess-r-help-command): New variable to allow
	htmlhelp to be set.
	* essd-r.el (R-customize-alist): Use above var.

2009-09-21  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-mode.el (ess-electric-brace): skeleton-pair
	takes precedence

2009-09-02  Rodney Sparapani  <rsparapa@mcw.edu>

	* essa-sas.el (ess-sas-rtf-portrait): OpenOffice Writer
	and Microsoft Word have different default margins which
	often leads to the same document displayed differently
	in each of the applications.  The wider OOWriter margins
	are now enforced so that either application can be used to
	view the documents correctly.

2009-08-05  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-cust.el (ess-r-args-electric-paren): must default to nil
	requires a conscious decision to turn on since it will
	mysteriously override smart-paren features like skeleton-pair

	* ess-mode.el (ess-mode): define "(" key only when
	ess-r-args-electric-paren is t for similar reasons

2009-06-16  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-trns.el (ess-transcript-send-command-and-move):
	patch supplied by tyler.smith@mail.mcgill.ca
	see the related discussion at
	https://stat.ethz.ch/pipermail/ess-bugs/2008q1/000489.html

2009-06-08  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-eval-linewise): keep deactivate-mark local

2009-06-05  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords):
	missed an abbreviated keyword

2009-06-05  Stephen Eglen  <stephen@gnu.org>

	* ess-utils.el (ess-change-directory): New function.

2009-06-04  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-utils.el (ess-num-or-zero):
	added (ess-num-or-zero arg)
	If arg is a number, then return that number, otherwise return 0

	* essa-sas.el (ess-sas-goto): fix the long-time
	bug of generating an error in (ess-sas-goto "log")
	when .log does not exist

2009-06-03  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords):
	adding a few more rare NOTES

	* ess-mode.el (ess-mode): turn off annoying
	message by default, pass nil to turn it back on
	(ess-set-style something nil)

2009-06-02  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): kill a
	false positive bug for ERRORs/WARNINGs

2009-06-01  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): in:
	needs to be a special case for some reason

2009-05-28  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): last tweak to
	comment statement identification (very optimistic)

	* essa-sas.el (ess-sas-goto-log): no longer highlighting error messages
 this feature never worked quite right (and was XEmacs only which is worse)
 after highlighting an error message, moving point would cause an unwanted
 highlighting between point and mark; why god, why?!?

2009-05-27  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords):
	get MPRINT right in the case where it is
	followed by a comment and add Pipe command=
	and fix functions finally

2009-05-26  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): make call
	functions explicit, correct a few omissions, add RX
	functions...  note that not all functions are yet on
	the list as there are LOTS of functions
	also, fixing a bug... int( should only be matched
	at the beginning of a word, however, it seems to
	also be finding MPRINT(.  there must be a bug
	in the font-locking code somewhere

2009-05-22  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-bugs.el, essd-bugs.el, essd-jags.el, essl-sas.el,
	essa-sas.el: update headers/copyrights

	* essl-sas.el (SAS-mode-font-lock-keywords):
	fine-tuning ERRORs/WARNINGs

2009-05-21  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): a few
	minor changes, ERRORs/NOTEs/WARNINGs

2009-05-20  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): fix
	error messages that go to two lines and kill a
	long-running bug biting adjacent comments
	/* comment type 1 */ followed by
	* comment type 2 ;
	migration complete! (should have done it 9 years ago)
	there are certainly going to be some special/missed
	cases of false positives/negatives
	(bug reports and patches welcome!)

2009-05-19  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): more
	alphabetizing, re-arranging, etc.  99.95%

2009-05-18  Rodney Sparapani  <rsparapa@mcw.edu>

	* essa-sas.el (ess-sas-toggle-sas-log-mode): really,
	really fixed now (3rd times a charm)

2009-05-15  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-eldoc.el/ess-roxygen.el/ess-toolbar.el:
	added GPLv2 or later header, etc.

	* essl-sas.el (SAS-mode-font-lock-keywords):
	a few fixes for functions and a missed NOTE

2009-05-14  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords):
	major overhaul complete (99.9%)
	PROCs now highlighted
	most keywords recognized (however, some
	dataset options are still needed)
	NOTEs and WARNINGs better detected in .log

	(ess-sas-run-regexp-opt): the new font-locking
	is better in many ways than the old font-locking
	so the default is now to use it; set this
	variable to nil to use the old font-lock code

	* essa-sas.el (ess-sas-toggle-sas-log-mode):
	still trying to get this right, first kill
	.log buffer, then re-open (see below)

2009-05-13  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): a
	few more keywords, a bug-fix and some comment
	re-organization, 99.5%

2009-05-12  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): even
	more fixes

2009-05-11  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): more
	simplification/alphabetization; 99% complete

2009-05-08  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-font-lock.el (ess-font-lock-rmh, etc.): modify
	so they work on XEmacs

	* essl-sas.el (SAS-mode-font-lock-keywords): more fixes
	and some alphabetizing (seriously, let's keep these in
	order, otherwise, it is very difficult to maintain)
	95% of the hand-coded regexps now handled by regexp-opt,

2009-05-04  Rodney Sparapani  <rsparapa@mcw.edu>

	* essa-sas.el (ess-sas-toggle-sas-log-mode): to re-font-lock,
	reverting may not be enough; killing buffer and re-opening is
	necessary in some circumstances

	* essl-sas.el (SAS-mode-font-lock-keywords): 3/4's of the way
	there.  regexp-opt code updated to a reasonable fax of the
	font-lock code it replaced.

2009-04-20  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (ess-sas-run-regexp-opt): the long overdue change
	from make-regexp to regexp-opt is under way.  Setting
	ess-sas-run-regexp-opt to something other than nil will result
	in the old make-regexp code to be used by regexp-opt.  This is
	a half-step in the right direction.  The regexp-opt code will
	be easier to maintain than the hand-coded regexps.  However,
	this means that the font-locking will revert to what it was
	circa 2001-2 :o(  Over time, this code will be upgraded so
	that the font-locking will be up-to-date with what is
	currently available and incorporate the changes necessary for
	v. 9.2 and beyond.

2009-04-01  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): add PROC MAPIMPORT

2009-03-16  Stephen Eglen  <stephen@gnu.org>

	* ess-toolbar.el (ess-make-toolbar-emacs): For Emacs 23, images
	need to be on image-load-path.  This variable is set at bottom of
	the file.

2009-03-13  Stephen Eglen  <stephen@gnu.org>

	* essd-bugs.el (ess-bugs-mode): Set comment-start to provide basic
	comment functionality.

2009-03-05  Rodney Sparapani  <rsparapa@mcw.edu>

	* essa-sas.el (ess-sas-rtf-portrait, ess-sas-rtf-us-landscape,
	ess-sas-rtf-a4-landscape): after creation, close rtf buffer,
	avoids an annoying confirmation question about visiting buffer

2009-02-26  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-bugs.el (ess-bugs-hot-arrow):
	Substitute <- for = key press

2009-01-30  Stephen Eglen  <stephen@gnu.org>

	* essd-r-args.el (tooltip-show-at-point): New function.
	Contributed by Erik Iverson <iverson@biostat.wisc.edu>.
	(ess-r-args-show): Use tooltip-show-at-point.

2009-01-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-mode): use run-mode-hooks only in newer Emacsen

2009-01-08  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essddr.el (Rd-keywords): new + shuffling + comment

	* essd-sas.el (SAS-mode): activate a bug fix;
	BTW, it's for 22.3 and 22.2

2009-01-07  Rodney Sparapani  <rsparapa@mcw.edu>

	* essd-sas.el (SAS-mode): fix a bug in GNU Emacs 22.3.1
	which erroneously performs font-lock on lowercase only

2008-12-17  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-site.el: we no longer should be encouraging
	users to edit this file (except possibly in extraordinary
	circumstances in 2 places).  Therefore, I have removed
	all but 2 references to uncommenting of code.  However,
	the examples are instructive so they remain, but the
	wording does not suggest uncommenting.  This is only a half-step
	in the direction that we want to go.

2008-12-15  Rodney Sparapani  <rsparapa@mcw.edu>

	* essd-jags.el (ess-jags-switch-to-suffix, ess-jags-na-bug):
	adding 2 new local variables:  ess-jags-burnin and
	ess-jags-update.  ESS[BUGS] has similar variables, but
	the modern defaults are an order of magnitude bigger, so
	it seemed like creating new variables was warranted
	also, the "log" of the run is now .jog (like BUGS which
	is .bog); .out created too many problems since the BOA
	output files have that extension as well

2008-12-11  Martin Maechler  <maechler@stat.math.ethz.ch>

	* noweb-mode.el (noweb-indent-line): update chunk vector first:
	fixes buglet {[Enter] in almost empty *.Rnw buffer} reported by
	Henric Nilsson.
	(noweb-code-quotes-handling): now *disables* by default the calling
	of the (noweb-hide-code-quotes) .. (noweb-restore-code-quotes) pair,
	consequently preventing catastrophic behavior in large *.Rnw files
	with "[[" in R output.

2008-12-04  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-mode.el/ess-trns.el: delete key no longer
	remapped to "backspace"

2008-12-04  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el: ess-r-versions-created currently needed too.

2008-11-29  Martin Maechler  <maechler@stat.math.ethz.ch>

	* noweb-mode.el: TODO cleanup; notably replacing more
	(stringp (car (noweb-find-chunk))) by (noweb-in-code-chunk).

	* noweb-mode.el (noweb-mode): use before-change-functions,
	noweb-chunk-boundary-changed etc; code from Markus Triska.


2008-11-28  Martin Maechler  <maechler@stat.math.ethz.ch>

	* noweb-mode.el (noweb-electric-<): {from Markus Triska}: also
	insert a (closing) "@".

	* ess-emcs.el (w32-short-file-name): Xemacs 21.5(beta) on Windows
	does not know win32-short-file-name anymore, but mswindows-*.

2008-11-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-emcs.el (ess-has-tooltip): move from ./ess-cust.el and test
	for Emacs >= 21.x.
	Consequently ESS works again in 'emacs-20.7 -nw'.

2008-11-26  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-swv.el (ess-swv-menu): a version that "works" with Xemacs;
	still with a FIXME.

	* noweb-mode.el, ess-rdired.el: replace (next-line .) by
	(forward-line .); also get rid of compilation warning about
	noweb-font-lock-mode.

2008-11-25  Martin Maechler  <maechler@stat.math.ethz.ch>

	* noweb-mode.el (noweb-mode): fix "add-local-hook" thinko;
	also correctly indent (and use ';;' for full-line comments)

2008-11-24  Rodney Sparapani  <rsparapa@mcw.edu>

	* essd-jags.el (ess-jags-mode): adding comment-region
	functionality to ESS[JAGS]

	* essd-jags.el (ess-jags-switch-to-suffix): JAGS 1.0.3 is
	very finicky about monitor-ing AND thin-ing; the syntax
	and semantics are primitive; most likely this will be
	re-visited in a future release of JAGS; in the time being,
	a minor change to ESS[JAGS] and the recommendation that
	variables be monitor-ed implicitly via the Local Variable
	ess-jags-monitor

2008-11-20  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-swv.el (noweb-minor-mode-menu): add to "Noweb" menubar menu.

2008-11-17  Rodney Sparapani  <rsparapa@mcw.edu>

	* Makefile (essl-sas.elc): Added formerly
	unaccounted for essa-sas.el dependency.

	* Makefile (essl-bugs.elc/essd-bugs.elc/essd-jags.elc): Added formerly
	unaccounted for BUGS/JAGS targets/dependencies.

2008-11-14  Stephen Eglen  <stephen@gnu.org>

	* essd-r.el (R-mode): Add keybinding (C-c C-o) for ess-roxygen-fn.

	* ess-site.el (ess-roxygen-fn): Add autoload.

	* ess-roxygen.el (ess-roxygen-fn): Ensure that newlines before and
	after template are inserted correctly.

2008-11-13  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-editing-alist): M-x comment-region
	was not using /* */ style comments for some reason that
	I can't fathom.  It is now.

2008-11-10  Rodney Sparapani  <rsparapa@mcw.edu>

	* noweb-mode.el (noweb-mode): Only the local value of
	after-change-functions should be modified to avoid problems
	in other modes.  Special thanks for the bug report/fix from
	markus.triska@gmx.at

	* noweb-mode.el (noweb-mode):  By convention, every major mode
	starts by calling `kill-all-local-variables'. Importantly, this
	automatically calls `change-major-mode-hook'. This is documented
	in the "Major Mode Conventions" of the Elisp info manual. Special
	thanks (again :o) for the bug report/fix from markus.triska@gmx.at

	* ess-mode.el (ess-mode): `ess-mode' should use `run-mode-hooks'
	rather than `run-hooks', because it is a major mode.  This way,
	you ensure that `change-major-mode-hook' is called (and everything
	else).  Special thanks for the bug report/fix from
	david.reitter@gmail.com

2008-11-06  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-swv.el: fix for embedded blanks in PDF reader and PDF files

2008-10-28  Rodney Sparapani  <rsparapa@mcw.edu>

	* ess-cust.el (ess-sta-delimiter-friendly): see below

	* ess-inf.el (ess-eval-linewise): Stata allows semi-colons to be
	used in batch, but not interactive processing.  This leads to
	madness when you are trying to step through a file that was
	written for batch with semi-colons.  Now, if you set
	ess-sta-delimiter-friendly to t (in the ess-Stata group),
	iESS[Stata] will convert semi-colons to newlines on-the-fly.
	Beware if you have string literals with embedded semi-colons
	as this simple fix does not check for such complexity.

2008-08-30  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-R-common-font-lock-keywords): new variable for
	better modularization
	(inferior-ess-R-font-lock-keywords): now with*OUT* the keywords.
	Ditto for -S- instead of -R- .

2008-08-25  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-end-of-function): more careful final advance.

2008-08-24  Stephen Eglen  <stephen@gnu.org>

	* ess-roxygen.el (ess-roxygen-fn): Use ##' for markup so that
	comments don't move upon reindentation.

2008-08-23  Stephen Eglen  <stephen@gnu.org>

	* ess-roxygen.el: New file.

2008-08-20  Martin Maechler  <maechler@stat.math.ethz.ch>

	* noweb-mode.el (noweb-set-chunk-code-mode): use
	(regexp-quote chunk-name) instead of just chunk-name,
	here and in another few cases.
	Thanks to a patch from  Rafael Laboissiere at Debian.

2008-07-30  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-eval-region): (deactivate-mark)
	when the new customizable variable
	* ess-cust.el (ess-eval-deactivate-mark): is non-nil.

2008-07-28  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-end-of-function): tweak

2008-07-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-end-of-function): if not at end of line move further.

2008-07-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r-args.el (ess-r-args-auto-show): only "act" if ess process
	is still active

2008-07-18  Rodney Sparapany  <rsparapa@mcw.edu>

	* essd-jags.el (ess-jags-switch-to-suffix): using ess-jags-system;
	see long svn message

2008-06-12  Stephen Eglen  <stephen@gnu.org>

	* essd-r.el (ess-R-complete-object-name): comint-bol given nil
	argument to work on XEmacs (the arg is optional on Emacs, but not
	in XEmacs).

2008-06-09  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (get-ess-process): if NAME is not running, do not
	automatically restart a new process, if there are others running.

2008-06-03  Stephen Eglen  <stephen@gnu.org>

	* ess-cust.el (ess-default-style): Remove quote from RRR value.

2008-05-24  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-start-process-specific): new function,
	implementing the process (re)start of yesterday
	(get-ess-process): also call ess-start-process-specific) if the
	process is no longer running.
	(ess-eval-line-and-step): (save-excursion ..) even earlier.

2008-05-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-request-a-process): when there is no associated
	ess process, start R automagically if ess-language is "S"

2008-05-22  Stephen Eglen  <stephen@gnu.org>

	* Makefile (ELC): Add ess-eldoc.elc to the ELC variable list.
	Debian bug 482351 reported by Sebastian Luque.

2008-05-19  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el: use make-local-variable 'comint-use... to silence warning

2008-04-10  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-use-R-completion): customizable boolean for this:

	* ess-inf.el (ess-internal-complete-object-name): new name for
	original (ess-complete-object-name).
	* ess-inf.el (ess-complete-object-name): now simple wrapper to
	either ess-R-complete-object-name or ess-internal-complete-object-name.

	* essd-r.el (R): use ess-R-complete-object-name for
	R versions >= 2.5.0 {where pkg 'rcompgen' became recommended};
	check for baseenv() only for older versions of R.

2008-04-07  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-emcs.el (ess-line-beginning-position): defalias renamed
	from original 'line-beg...' in order to be good emacs citizens.

2008-03-31  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (R-fix-T-F): remove "_" (and extraneous "\"); thanks to Stephen

2008-03-31  Stephen Eglen  <stephen@gnu.org>

	* ess-mode.el (ess-continued-statement-p): remove _ from regexp to
	fix Kurt's bug re indendation after NA_INTEGER_

2008-03-11  Stephen Eglen  <stephen@gnu.org>

	* ess-cust.el (custom): Remove old code checking if custom package
	is provided; custom is now in all recent versions of Emacs and
	XEmacs.

2008-03-11  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (ess-current-R-version, ess-current-R-at-least): two
	new utilities.
	* essd-r.el (ess-R-complete-object-name): modified from Jim
	MacDonald's 'alt-ess-complete-object-name, to work in R >= 2.7.0.

2008-03-05  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (inferior-R-input-sender): wrap into
	(save-current-buffer . ); thanks to patch from Lawrence Mitchell.

2008-01-17  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-noweb.el (ess-noweb-use-font-lock): change default
	from window-system to font-lock-mode

2008-01-08  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-fix-miscellaneous): no 'literal in fixing ";  #"

2007-12-28  Stephen Eglen  <stephen@gnu.org>

	* essd-sp6w.el (S+6-dialect-name): Make defcustom and change
	default to "S".  Change of default suggested by Tim Hesterberg.

2007-12-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-mode): set style to ess-style which is now in
	ess-mode-editing-alist .. which is now correctly defined in
	* essl-s.el (R-editing-alist): etc

2007-12-11  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (inferior-ess-primary-prompt): s / * / ? /

	* ess-inf.el (ess-command): new optional argument 'no-prompt-check
	(ess-get-words-from-vector): ditto;
	make use of (ess-if-verbose-write);
	trailing white space "nuking"

	* ess.el: (ess-if-verbose-write): new shortcut for more compact
	code in other places.

2007-11-08  Stephen Eglen  <stephen@gnu.org>

	* ess-eldoc.el (ess-eldoc): Prefix the docstring by the name of
	the function, for readability.

2007-11-07  Stephen Eglen  <stephen@gnu.org>

	* ess-cust.el (ess-font-lock-mode): New variable.
	* ess-site.el: Use ess-font-lock-mode.


2007-09-28  Martin for Rodney Sparapany  <rsparapa@mcw.edu>

	* essd-r.el (ess-find-rterm): yet another "replace \\ by /",
	needed for Xemacs (on Windows).

2007-09-12  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (ess-r-versions-create): merged
	ess-rterm-versions-create into this one, using (if ..microsoft..);
	* ess-site.el: ditto


	* essd-r.el (ess-find-newest-R): fix M$: use ess-rterm-version-paths
	(ess-check-R-program-name): renamed from ess-check-R-name

	* ess-cust.el (ess-rterm-version-paths): add to doc string

	* ess-site.el: cleanup comments in "finding R versions" part

2007-09-11  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el (ess-versions-created): slightly more parallelism
	between microsoft and "normal".

	* ess-utils.el: remove long deprecated (defun ess-directory-sep)
	(ess-chop1, ess-drop-non-directories): new utilities.

	* essd-r.el (ess-r-versions-create): and
	(ess-rterm-versions-create): parallelized much more, to be merged
	later.
	(ess-find-rterm): now make use of ess-drop-non-directories:
	a "zip" file starting with R-2.6 now longer harms.

2007-09-10  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (R-editor et al): use "gnuclient" instead of "... -q"
	for Xemacs

2007-09-03  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-comp.el (ess-message): use format-string - exactly
	* ess-site.el: {ditto}       paralleling (message .);  such that
	we can use (... "%s" msg) as recommended in here:
	* essd-r-args.el (ess-r-args-show):

2007-08-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-SHOME-versions, et al): use (getenv "ProgramFiles")
	instead of "c:/progra~1..."; ditto in
	* essd-r.el etc.

2007-08-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el: replace kludgey (defun find-load-file-directory)
	by simple (locate-library .) thanks to a hint from Philipp Lord.

2007-08-15  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r-args.el (require 'tooltip): only when ess-has-tooltip
	is set; which is the case by default when *not* in Xemacs.

2007-07-26  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-r-args-electric-paren): default changed to t;
	newbies should see the new feature automatically.

2007-07-24  Stephen Eglen  <stephen@gnu.org>

	* essd-r.el (ess-find-newest-R): New defun, to find the newest
	version of R, either for Unix or Windows.  Result is cached in a
	variable, ess-newest-R.
	(ess-check-R-name): New defun to check that
	inferior-R-program-name points to an executable.
	(R-newest): Use ess-find-newest-R defun.
	(ess-find-newest-R): Add message whilst searching.

	* ess-site.el: Call ess-check-R-name once, upon startup.
	Searching for newest version takes place only if
	inferior-R-program-name is invalid.

2007-07-23  Stephen Eglen  <stephen@gnu.org>

	* ess-eldoc.el (ess-eldoc): Use ess-local-process-name rather than
	ess-current-process-name.


2007-07-21  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-command): Use with-current-buffer and simplify.

	* ess-help.el (ess-help-underline): Fix indenting.
	(ess-describe-sec-map): Use with-current-buffer.

2007-07-21  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess.el (ess-write-to-dribble-buffer): patch from Markus Triska
	<markus.triska@gmx.at>.  Most importantly, deactivate-mark is set
	to nil so that any active region is not affected.  (Without this,
	in transient-mark-mode in GNU Emacs, highlighting of the region is
	lost when moving over chunks, and M-h (= mark-paragraph) on chunks
	doesn't work as expected.).  Now also use with-current-buffer.

2007-07-16  Stephen Eglen  <stephen@gnu.org>

	* ess-site.el (ess-sqpe-versions-created): Remove call to
	ess-newest-R, and instead allow R-newest to find the newest
	version of R.  This relies on a new devar, ess-r-versions-created,
	to store the other versions of R that were found when ess-site was
	loaded.


	* essd-r.el (R-newest): New defun.  First time it is called, try
	to find the newest version of R.
	(ess-newest-r): Just return the name of the newst version of R;
	let R-newest do the fset call.

	* ess-mode.el (ess-function-pattern): Add defvar to quieten byte
	compiler.

	* ess-help.el (ess-help-mode): No need to make
	ess-local-process-name buffer local; that's done elsewhere.
	* ess-inf.el (ess-execute):  Ditto.


	* ess-cust.el: Update many doc strings, and change some vars from
	defcustom to defvar.

2007-07-14  Stephen Eglen  <stephen@gnu.org>

	* essd-r.el (ess-find-newest-date): this-r should be a local var.

2007-07-13  Stephen Eglen  <stephen@gnu.org>

	* essd-r.el (ess-r-version-date): New defun, replacing
	ess-r-version-time as it returns the date stamp of R as a string
	rather than a time in seconds.
	(ess-find-newest-date): New defun, replacing
	ess-which-newest-date.


2007-07-11  Stephen Eglen  <stephen@gnu.org>

	* essd-r.el (ess-newest-r, ess-r-version-time, ess-which-newest):
	New defuns to find the newest version of R.

	* ess-site.el (ess-sqpe-versions-created): Use ess-newest-r.

2007-07-01  Stephen Eglen  <stephen@gnu.org>

	* ess-eldoc.el: New file: add support for ELDOC in R buffers.

	* essd-r-args.el (ess-r-args-get): Use ?\( rather than using
	string-to-char.  Other small typo/doc fixes.


2007-06-29  Stephen Eglen  <stephen@gnu.org>

	* essl-sta.el (ordinary-insertion-filter): Delete this defun, it
	is also in ess-inf.el

	* ess-inf.el (inferior-ess-mode): Ensure font-lock-keywords-only
	is t (to fix bug in Emacs 22.1).  Other small changes:
	- using `member' rather than lots of `string=' comparisons.
	- replacing (if cond (progn ...)) by (when cond ...)
	- replacing:
	(make-local-variable some-var)
	(setq some-var val)
	with
	(set (make-local-variable some-var) val)


2007-06-27  Stephen Eglen  <stephen@gnu.org>

	* ess-site.el (ess-restore-asm-extns): use `when' rather than
	`(if x (progn ...))'.

2007-06-13  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-r-args-electric-paren): new custom variable to
	be used to toggle the `electric "(" behavior' in essd-r-args.el

	* ess-mode.el (ess-mode): define-key .. "(" if ..-electric-paren is set.

	* essd-r-args.el (ess-r-args-auto-show): new small function;
	activated by the above custom variable.

	(ess-r-args-get): use 'force ==> less asking for process


2007-06-13  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el (SAS-mode-font-lock-keywords): fix in the
	"dlreg|hreg|..." regular expresseion.

2007-05-21  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-request-a-process): give (message .) when not
	asking {see 2007-05-03}.

2007-05-11  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-r-args-show-as): and others: moved
	(defvar ...) to
	* essd-r-args.el: and changed to (defcustom ...)
	* ess-cust.el (ess-S-non-functions): new variable to be used by
	* ess-cust.el (ess-r-args-keep-silent): new customizable variable.

2007-05-04  Stephen Eglen  <stephen@gnu.org>

	* essd-r.el(?`): define the backquote (`) character to be in the
	quote character syntax class.

	* ess-cust.el: Doc fix to comment regarding regexps for finding R
	functions.


2007-05-03  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-request-a-process): Don't ask if there's only one
	process.

	* ess.el (ess-get-ps-viewer, ess-get-pdf-viewer): new functions,
	currently used in
	* ess-swv.el (ess-swv-PS, ess-swv-PDF): cleaned up; using the above and
	(ess-swv-run-in-R): fix bug in (message .);
	start R automatically if none is running.
	(ess-swv-PDF): use (call-process .) return value to detect
	errors from pdflatex.

	* ess-cust.el (ess-pdf-viewer-pref, ess-ps-viewer-pref): new
	user customizable variables.

2007-05-01  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r-args.el: new functionality donated from
	Sven Hartenstein, see http://www.svenhartenstein.de/emacs-ess.php

2007-04-26  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-get-words-from-vector): Doc fix.

2007-03-16  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-swv.el (ess-swv-tangle): new; also rename all the
	ess-make<Foo> to  ess-swv-<Foo>; and add back-compatibility
	wrappers (with warning)

2007-01-27  Stephen Eglen  <stephen@gnu.org>

	* essd-sp6w.el (S+6-msdos-initiate, S+6-initiate): Do not
	use (beginning-of-buffer), as it clobbers the mark.

2007-01-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (inferior-ess-safe-names-command): new
	try(names(.)); this finally gets rid of "hanging" in object
	completion, e.g., when options(error=recover) is active in R.

	* ess-inf.el (ess-object-names): using the above ..-safe-names-..


2007-01-08  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essa-sas.el (ess-sleep): eliminated, since no xemacs/emacs
	distinction needed: GNU emacs can well (sleep-for 0.12)

2007-01-06  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el (ess-microsoft-p): issue "options(chmhelp = FALSE)"
	for microsoft-p

2007-01-05  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-eval-linewise): new argument 'wait-last-prompt'
	and 'sleep-sec'
	* ess-inf.el (ess-execute-screen-options): use wait-last.. and sleep-sec

	* ess-dde.el (ess-eval-linewise-ddeclient): use sleep-sec

	* essd-r.el (R): using ess-eval-linewise + 'wait (2 x)

	* ess-cust.el (ess-eval-linewise-sleep): new variable; default 0.06

2006-12-08  Stephen Eglen  <stephen@gnu.org>

	* ess-cust.el (Rnw-mode-hook): New hook.

	* essd-r.el (Rnw-mode): Use Rnw-mode-hook.

2006-12-07  Stephen Eglen  <stephen@gnu.org>

	* ess-utils.el (ess-sci-to-dec), essl-bug.el
	(ess-bugs-sci-to-round-4-dp), essl-bugs.el
	(ess-bugs-sci-to-round-4-dp), essd-s4.el: string-to-int is
	deprecated; use string-to-number.

2006-12-03  Stephen Eglen  <stephen@gnu.org>

	* noweb-mode.el (noweb-newline): Add noweb-indent-line.

2006-11-25  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-swv.el (ess-makePS, ess-makePDF): search for PS and PDF
	viewer instead of using having 'gv' and 'acroread' hardcoded;
	thanks to patch from Leo <sdl at web_de>.

2006-10-27  Stephen Eglen  <stephen@gnu.org>

	* ess-help.el (ess-submit-bug-report): Add note to use C-c C-c to
	send bug report.

2006-09-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essddr.el (Rd-mode-insert-skeleton): add final "\n"

2006-09-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-mode-menu): move "ess-execute" up; the menus
	are for beginners after all.

	* ess-inf.el (ess-command): make sure final prompt is deleted (again!).

	* ess-cust.el (ess-display-buffer-reuse-frames): new variable,
	defaulting to 't which is now used by
	* ess-inf.el (ess-display-temp-buffer): uses the above.
	Consequently, (ess-execute) reuses an *ess-output* frame.

2006-09-15  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-command): get rid of ess-save-lastvalue-command
	* .... also in some other places.
	Consequently we no longer mess with .Last.value in the S dialects.

2006-09-14  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-complete-object-name): add comment
	(ess-get-object-list): some more (ess-write-to-dribble-..)
	diagnostic output.

2006-08-31  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-swv.el (ess-makeLatex): improved

2006-08-30  Martin Maechler  <maechler@stat.math.ethz.ch>

	* noweb-mode.el (noweb-mode-prefix-map): do *not* override M-n C-h

2006-08-28  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-swv.el (ess-makeSweave): improve to show *R* buffer;
	also add comments about more "TODO"s

	* ess-swv.el (ess-make*): using (search .) needs 'cl.

2006-07-31  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essddr.el (Rd-mode-map): add C-c C-c (as in ess-mode)

2006-05-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (Snw-mode): synonym for Rnw-mode
	* ess-site.el (auto-mode-alist): *.Snw -> Snw-mode

	* essl-s.el (ess-toggle-S-assign-key): changes
	(ess-S-assign-key): new default -- the one Seth uses.

2006-05-16  Stephen Eglen  <stephen@gnu.org>

	* ess-utils.el (ess-find-exec): Remove explicit loop counter (i) and
	rewrite while loop.
	(ess-find-exec-completions): Remove explicit loop counters (i,j) and
	rewrite while loops.  Add test to check that a directory on
	exec-path is not "" (which signifies current working directory) as
	that confuses tramp.
	(ess-return-list): Indent/doc fix.
	(ess-clone-local-variables): Indent.
	(ess-directory-sep): Indent (perhaps this should be deleted?)

2006-05-12  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (R-site-search): experimental function provided by
	Sebastian Luque on ess-help, May 1--2, 2006

2006-05-03  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-eval-function): and *-or-para...:
	use (ess-read-object-name-default) instead of simpler but slightly buggy
	(ess-extract-word-name).

2006-04-29  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-mode-map): work around Xemacs bug ("Meta backspace")

2006-04-04  Richard M. Heiberger <rmh@temple.edu>
	* essd-sp6w.el (S+6) and (S+6-msdos): change string to detect S-Plus 6.0,
	previous string was catching the date 2006.03.30.
	* ess-cust.el (ess-SHOME-versions): add splus80

2006-04-03  Richard M. Heiberger <rmh@temple.edu>
	* ess-help.el (inferior-ess-help-filetype): distinguish between
	regular S language help files that can appear in an emacs buffer
	and "chm" (compiled html) used by S-Plus that cannot appear in
	an emacs buffer.
	* essd-r.el
	* essd-s*[3456]*.el
	* ess-cust.el
	* ess-inf.el
	* ess-mode.el

2006-04-03  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-show-buffer): Use
	ess-select-frame-set-input-focus.
	* ess-utils.el (ess-select-frame-set-input-focus): New defun.

2006-03-26  Stephen Eglen  <stephen@gnu.org>

	* ess-help.el (ess-help-mode): Dynamically set section keys.
	(ess-submit-bug-report): Use insert-buffer-substring, not
	insert-buffer (byte compiler warning).

2006-03-25  Stephen Eglen  <stephen@gnu.org>

	* ess-help.el (ess-describe-sec-map): make sure to get proper
	*-sec-keys-alist

2006-03-24  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-eval-linewise): now calls
	(ess-eval-linewise-ddeclient .) when appropriate; similar in other
	functions; the same applies to
	* ess-help.el:	autoload and *-ddeclient functions when needed.
	* ess-mode.el:	dito

	* ess-dde.el: renamed from ess-iw32.el: removed all function
	*RE*definitions and all (require .) leaving only `*-ddeclient'
	function definitions;

	* ess-help.el(ess-help-mode-map): and menu; added one of the new
	ess-eval-*and-step (of a week ago).

2006-03-23  Richard M. Heiberger <rmh@temple.edu>
	* ess-iw32.el (ess-display-help-on-object)
	repair prompt on Windows to suggest a default as on Unix.

2006-03-21  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-toggle-S-assign-key): based on code by Seth Falcon;
	see ESS-help; TODO: a better 'toggle'

2006-03-17  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-eval-paragraph-and-step): new;
		     (ess-eval-paragraph-and-go): dito.
	(ess-eval-region): now returns a (beg end) list

	(ess-eval-function-or-paragraph-and-step): new, to be bound to C-cC-c

	* ess-mode.el (ess-beginning-of-function): &optional no-error
	(ess-mode-map): add ess-eval-paragraph-and-(go|step) and
			ess-eval-function-or-paragraph-and-step
	(ess-mode-menu): dito

2006-03-02  Stephen Eglen  <stephen@gnu.org>

	* ess-utils.el (ess-find-exec-completions): Doc fix.

2006-03-01  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-execute-screen-options): fix for case where
	there's more than one S process.

2006-02-09  AJ Rossini <blindglobe@gmail.com>

	* ess-comp.el: copyright dates changed.
	* ess-debug.el: added minimal documentation.  Removed cruft (this
	is cruft?).  copyright dates changed.

2006-02-09  Anthony Rossini <anthony.rossini@novartis.com>

	* ess-inf.el (ess-proc-name): better logic, cleanup.
	* ess-cust.el (ess-use-inferior-program-name-in-buffer-name): new variable.
	* ess-site.el: documentation for this
	* ess-inf.el (inferior-ess): use new variable for buffername
	construction.

2006-02-09  Anthony Rossini <anthony.rossini@novartis.com>

	* ess-inf.el (ess-proc-name): cleaned up truly ugly logic.

2006-02-08  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-dump-to-src): minimal improvement

2006-02-04  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-sas.el (SAS-mode-font-lock-keywords): font-lock in any case,
	also for dumb terminals

2006-01-20  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-add-MM-keys): add *-execute-screen-options

2006-01-06  Stephen Eglen  <stephen@gnu.org>

	* ess-install.el (ess-install-byte-compile): New defun.

	* msdos.el (msdos-minor-mode): Shouldn't msdos-minor-mode be
	defined earlier in the file?  Have not moved yet, as I cannot test
	on Unix.

	* ess-swv.el (ess-makePS): let* needed so that namestem can be
	used within definitions of let.

	* ess-inf.el (ess-bufs-in-frame): Defvar.

	* mouseme.el (mouse-me-execute): This function is broken, so I've
	made it just report an error [w32-shell-execute not present].

	* essddr.el (Rd-font-list): Move to top of document, before it is
	used in defuns.
	(Rd-active-mark): Put empty definition of defun before defining
	conditional on Emacs/Xemacs.  This silences the compiler.

	* essd-sp4.el (S+4, S+4-msdos): Replace
	(beginning-of-buffer) with (goto-char (point-min)).

	* essd-sp3.el (S+3-mode): Correct call to imenu (defun was
	broken).

	* essd-r.el (ess-rterm-versions-create): version-root should be a
	local variable.

	* ess.el (ess-write-to-dribble-buffer): Chnage insert-string to
	insert.

	* ess-swv.el (ess-makeSweave): ess-command is local variable.

	* ess-rdired.el (ess-rdired-sort-num): Make defvar.

	* ess-mode.el (ess-parse-errors): Change string-to-int (obsolete)
	to string-to-number.

	* ess-iw32.el (ess-eval-region-ddeclient): Replace
	(beginning-of-buffer) with (goto-char (point-min)).

	* ess-emcs.el: Change string-to-int (obsolete) to
	string-to-number.

	* ess-cust.el (inferior-ess-primary-prompt): Add group, type.
	(inferior-ess-secondary-prompt): Add group, type.
	(ess-process-name-list): Make defvar.

	* ess-install.el: Add call to byte compiler to recompile all files
	in the new lisp directory.

2005-12-29  Stephen Eglen  <stephen@gnu.org>

	* essd-sp6.el (ess-s-versions-create): If ess-s-versions is nil, do
	not search for other versions of S using this method
	(ess-s-versions-list will still be examined).

	* essd-r.el (ess-r-versions-create): If ess-r-versions is nil, do
	not search for other versions of R.

2005-12-13  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (R-customize-alist): ess-*lastvalue-command's now use
		baseenv().
	(R): make sure 'baseenv()' will work.

2005-11-24  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-fix-EQ-assign): slight improvement in regexp.

2005-11-24  AJ Rossini <blindglobe@gmail.com>

	* essd-r.el (R): cygwin, at least older versions, probably need to
	consider adding the --ess flag rather than the --no-readline,
	since we most likely are using Rterm and not R.

2005-11-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-dump-args-and-go): don't use (replace-string ..)
	(ess-fix-miscellaneous): also remove trailing ";"

2005-11-09  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (inferior-ess): Update doc string to describe
	inferior-ess-same-window and inferior-ess-same-window.

	* essd-sp6.el (ess-s-versions-create): kill temporary buffer after
	new defuns have been loaded.

2005-11-07  AJ Rossini <blindglobe@gmail.com>

	* essa-sas.el (ess-sas-submit-pre-command): make sure that if
	there is no shell, i.e. (= (getenv "SHELL") nil), that we don't
	die.  This is true for old cygwins.

2005-10-12  Stephen Eglen  <stephen@gnu.org>

	* ess-toolbar.el (ess-add-icon-xemacs): Swap caddr for (nth 2)

	* essd-sp6.el (ess-s-versions-create): Use nth rather than car,
	cadr, caddr.  Much more readable and removes reliance on cl
	library for caddr.

2005-10-03  Stephen Eglen  <stephen@gnu.org>

	* essd-sp6.el (ess-s-versions-list): New variable.
	(ess-s-versions): New variable.
	(ess-s-versions-create): New defun to allow other versions of S to
	be added to ESS, similar to ess-r-versions-create.

2005-09-26  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (R): add space after inferior-R-args

2005-09-07  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-complete-filename): work around Xemacs bug:
	(comint-dynamic-complete-filename) fails in Xemacs 21.4.17

2005-09-06  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-trns.el (ess-transcript-mode-menu): add entry "Switch S process"

2005-09-02  Stephen Eglen  <stephen@gnu.org>

	* essd-r.el, ess-cust.el (ess-r-versions): Moved this variable
	from ess-cust.el.  (As a custom variable, it could be set after
	ess-site had been loaded, which is the time when its value is
	used.  Hence customized values were ignored.)
	(ess-r-versions-create): Apply unique to list of list of R
	binaries after stripping off the directory.  This prevents
	multiple entries with the same name occuring in the ESS -> Start
	Process -> Other menu.

2005-08-20  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-sta.el (STA-syntax-table): allow // for comments

2005-08-03  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (inferior-R-1-input-help): '^ *help': do not trigger
	for, e.g., showMyhelp().

2005-07-28  Stephen Eglen  <stephen@gnu.org>

	* ess-help.el (ess-nuke-help-bs): Add doc string and remove
	interactive specification.

2005-07-09  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-beginning-of-function):

	* ess-mode.el (ess-R-function-pattern) etc: moved here from
	* ess-cust.el: greatly improved to also catch things like
		 "names<-.foo" <- function(.) { .... }

2005-07-08  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-menu.el (ess-imenu-S-generic-expression): adding SetAs(..),
	but also e.g., setGroupMethod(..)

2005-07-05  Stephen Eglen  <stephen@gnu.org>

	* ess-help.el (ess-help-bogus-buffer-p): Document NR-FIRST, and
	reinstate code such that if NR-FIRST is nil, we search just the
	first 120 characters of a help buffer to see if it is bogus.  Have
	removed check for R text of the form "Help for topic `rlm'..."
	since this is caught elsewhere (see below).
	(ess-display-help-on-object): In R help buffers, if
	options("help.try.all.packages" = TRUE) then ?rlm will list which
	packages rlm is defined in.  This help buffer is not bogus, but
	instead is now relabelled *help[R](rlm in packages)*.

2005-07-05  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-beginning-of-function): more helpful error
	message for finding the bug with A <-  # comment ...  function(.){..}


2005-06-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-fix-EQ-assign): extend to propose more s/=/<-/

2005-05-05  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-complete-filename): Add doc string.
	(inferior-ess-mode): Change order of functions added to
	comint-dynamic-complete-functions local hook.  Removed the value
	`t' from that hook to prevent the global value of that hook also
	being used.

2005-04-16  Stephen Eglen  <stephen@gnu.org>

	* ess-toolbar.el (ess-make-toolbar): If Emacs is running in a
	terminal, tool-bar-map is not defined (because tool-bars cannot be
	displayed) and hence we should not bother trying to make a
	tool-bar.

2005-04-15  A.J. Rossini  <blindglobe@gmail.com>

	* ess-swv.el: New file for Sweave, slightly modified from code
	done by David Whiting.

2005-04-08  Stephen Eglen  <stephen@gnu.org>

	* essl-s.el (R-editing-alist): Changed comment-start to #
	and set comment-add to 1 so that ## is put on empty lines at
	correction indentation.

2005-04-07  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-mode-menu): add "Toggle Auto-Fill Mode"

2005-04-06  Stephen Eglen  <stephen@gnu.org>

	* ess-toolbar.el (ess-toolbar-items): Use :set so that when this
	variable is customized, the toolbar is remade for the current
	session.

2005-04-06  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-mode-hook): set *normal-*auto-fill-function, not
	auto-fill-function itself.

2005-03-21  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-emcs.el (enable-multibyte-characters): define (to nil) if
	not bound.  Workaround for Xemacs problems with (ess-do-auto-fill).

2005-03-08  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (inferior-ess-output-filter,
	inferior-ess-strip-ctrl-g): New defuns.
	(inferior-ess-output-filter): Add filter to catch ^G for ringing
	bell.  Code taken from Kurt's octave-mod.el.

2005-03-07  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-S-keywords): add "terminate"

2005-03-04  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el: use (regexp-opt .) constructor

2005-03-03  Martin Maechler  <maechler@stat.math.ethz.ch>
  based on much from Kurt Hornik

	* ess-cust.el (ess-R-function-pattern): and ess-S-function-pattern
		instead of ess-function-pattern.
	* essl-s.el (S+common-cust-alist): set ess-function-pattern
	* essd-r.el (R-customize-alist): set ess-function-pattern

	* ess-cust.el (ess-R-mode-font-lock-keywords): and ess-S-*
		instead of just one ess-mode-font-lock
	* essl-s.el (R-editing-alist): additionally to S-editing-alist
	* essd-r.el (R-customize-alist): use R-editing-alist


	* ess-cust.el (inferior-ess-R-font-lock-keywords): and ess-S-*
		instead of just one; building on auxiliary variables.
	* essl-s.el (S+common-cust-alist): set inferior-ess-font-lock-*
	* essd-r.el (R-customize-alist): dito


2005-03-03  Martin Maechler  <maechler@stat.math.ethz.ch>
  from	    Kurt Hornik	 <Kurt.Hornik@wu-wien.ac.at>

	* essl-s.el (add-hook 'ess-mode-hook): new ess-do-auto-fill

	* ess-emcs.el (line-beginning-position): if needed by older Xemacsen

	* ess-utils.el (ess-do-auto-fill): new - slight change of GNU
	emacs' do-auto-fill.
	* ess-utils.el (ess-inside-string-p): new
	(ess-inside-string-or-comment-p): renamed from 'inside-string/comment-p'

2005-02-11  Rodney Sparapani  <rsparapa@mcw.edu>

	* essl-sas.el: do not turn on sas-listing-mode via
	auto-mode-alist.

2005-02-09  Martin Maechler  <maechler@stat.math.ethz.ch>
	really
2005-02-09  Kurt Hornik	 <Kurt.Hornik@wu-wien.ac.at>

	* essd-r.el (R): do not (let .. default-process-coding-system) !!

2005-01-29  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-quit-r): comment out all "questioning":
	it's wrong to do this when a user had something like "--save" on
	startup.

2005-01-24  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-quit): drop 'dont-cleanup' argument

2005-01-24  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-cleanup): Use ess-S-quit-kill-buffers-p.

	* ess-cust.el (ess-S-quit-kill-buffers-p): New variable.

2005-01-22  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-quit-r): Default response (if RET pressed on its
	own) is that workspace image will not be saved.
	Do not append "-exited" to iESS buffers (likewise for ess-quit).

2005-01-18  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-quit-r): New function to handle killing an *R*
	process.  (ESS asks whether you wish to save image.)
	* ess-inf.el (ess-quit): Use ess-quit-R only for *R* processes.
	Document the dont-cleanup argument.

2005-01-18  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-complete-object-name): add S4 object slot name
	completion.
	* ess-inf.el (ess-slot-names): new (simplistic) function

2005-01-05  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-prompt-wait): new 3rd argument sleep
	 (ess-command): move the (sleep-for *) part into to
	 ess-prompt-wait.

	* ess-inf.el (ess-get-object-list): use ess-uniq-list to get
	  completion list of unique entries.

2005-01-04  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-cmd-delay): use this instead of
	`ess-need-delay': Either 'nil or a number specifying the delay
	*factor* to be used.

	* ess-inf.el, essl-s.el, essd-r.el: ditto


2005-01-01  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-command): 3rd argument sleep; internally using
	ess-need-delay; decreased sleep factors to (.05, .4, .05).

	* ess-cust.el (ess-need-delay): and ess-R-*, ess-S+-*: instead of
	ess-ms-slow.
	(ess-editor): and (ess-pager): defvar instead of defcustom

	* essl-s.el (S+common-cust-alist): and (S-common-cust-alist):
	 new variables to store all common S language and S+ "customize-alist"s

	* essd*.el (<dialect>-customize-alist): append the above variables

2004-12-30  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-save-lastvalue-command): newly (defvar .) and
	buffer local, {instead of defcustom}; ditto for ess-retr-last....

	* ess-cust.el: drop them here

2004-12-29  Stephen Eglen  <stephen@gnu.org>

	* ess-mode.el (ess-mode): Remove call to
	ess-load-object-name-db-file.

	* ess-menu.el (ess-imenu-S): Shorten doc string.

	* ess-inf.el (inferior-ess-mode): Remove vall to
	ess-load-object-name-db-file.
	(ess-create-object-name-db): Comment out for now, maybe delete later?

	* ess-cust.el (ess-object-name-db-file): Change from defcustom to
	defvar.	 Also, add note that probably this variable (and others)
	can be deleted in future ESS versions.

2004-12-24  Stephen Eglen  <stephen@gnu.org>

	* ess-emcs.el (ess-replace-regexp-in-string): New function,
	reapplied from Camm's patch.  This time the function is now used
	in all relevant customization-alists.  This function is needed
	since other elisp packages may also define
	replace-regexp-in-string.

2004-12-20  Stephen Eglen  <stephen@gnu.org>

	* ess-cust.el (ess-ms-slow): New variable.

	* ess-inf.el (ess-command): Condition use of sleep-for (to add
	delays) upon ess-microsoft-p [not 'window-system] and a new
	variable ess-ms-slow.

2004-12-04  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (inferior-ess-mode): setq inferior-ess-prompt at the
	start of function so that its value can be used later in the
	function (e.g. to set comint-prompt-regexp).

2004-12-03  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el: replace inferior-ess-objects-command by the two
	  inferior-R-objects-command and inferior-Splus-... (which differ).

	* ess-inf.el (inferior-ess-objects-command): defvar here, instead

	* essd-r.el, essd-sp6.el  -- and all essd-sp*.el essdsp6w.el:
	  replace inferior-ess-objects-command


2004-12-03  Stephen Eglen  <stephen@gnu.org>

	* ess-cust.el (inferior-ess-prompt): Make this a defvar as the
	value is constructed from other values, rather than being set by
	the user.

	* essd-els.el (ess-add-ess-process): Check first that the current
	buffer has a process.
	(ess-select-alist-dialect): Add colon to prompt string.

	* ess-inf.el (inferior-ess-mode): Set inferior-ess-mode here,
	rather than within ess-multi.  (ess-multi is not run when
	ess-remote is used, and so prompt was not set for remote buffers
	running ESS processes.)

2004-11-24  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (S-editing-alist): change comment-start from "#" to "##"

2004-11-19  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-noweb.el: remove setting of global-font-lock-mode

2004-11-09  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (inferior-ess-mode): Add elements to
	comint-dynamic-complete-functions using `add-hook' rather than
	`setq', on advice from Emacs developers.

2004-11-07  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-multi): Fix bug: when inferior-ess-own-frame is
	non-nil, it should override the value of inferior-ess-same-window.

2004-10-28  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-help.el: ess-help-mode-hook is now run correctly.

2004-10-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-sp6.el: added Debian patches from Camm Maguire
	* ess-help.el: dito for these:
	* ess-utils.el
	* ess.el
	* ess-latex.el
	* ess-emcs.el

2004-10-14  Stephen Eglen  <stephen@gnu.org>

	* ess-cust.el (ess-default-style): Customize.

2004-08-29  Stephen Eglen  <stephen@gnu.org>

	* ess-inf.el (ess-multi): Use inferior-ess-same-window to decide
	whether to replace or split current window.

	* ess-cust.el (inferior-ess-same-window): New variable.

2004-08-25  Stephen Eglen  <stephen@gnu.org>

	* essd-sp6.el (S+6-customize-alist): Use inferior-Splus-args.

	* ess-cust.el (inferior-Splus-args): New variable.

2004-08-24  Stephen Eglen  <stephen@gnu.org>

	* ess-cust.el (inferior-R-args): New variable.
	* essd-r.el (R): pass inferior-R-args to R when starting up.

2004-08-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (inferior-R-page): only match "page()", not
	"grid.newpage()" !!

2004-08-09  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-inf.el (ess-prompt-for-directory): use the XEmacs
	read-directory-name routine (dialog box when using mouse differs
	from read-file-name).  Thanks to John Fox for reporting this.

2004-08-03  Stephen Eglen  <stephen@bushmills.inf.ed.ac.uk>

	* ess-mode.el (ess-mode-menu): Change function name for the
	default entry in "Start Process -> Other" submenu from R to nil.
	When it was set to R, this caused the R toolbar icon to not work
	since this menu entry was being found rather than the real menu
	entry for R.


2004-07-09  Stephen Eglen  <stephen@bushmills.inf.ed.ac.uk>

	* ess-utils.el (ess-find-exec-completions): After checking that
	ess-tmp-file is executable, check that it is not a directory.

2004-07-04  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* essdsp6w.el (ess-sqpe-versions-created): Variable deleted.

	* essd-r.el (ess-r-versions-created): Variable deleted.
	(ess-rterm-versions-created): Variable deleted.

	* ess-site.el: Use let binding for storing local values of
	ess-r-versions-created etc, rather than global variables.  Global
	variables deleted.

2004-07-02  Richard Heiberger  <rmh@temple.edu>

	* essdsp6w.el (ess-sqpe-versions-create): New function to
	auto-generate defuns to allow other versions of Sqpe to be called.

	* essd-r.el (ess-rterm-versions-create): New function to auto-generate
	defuns to allow other Windows versions of R to be called.

2004-07-02  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* essd-r.el (ess-r-versions-create): Do not set the value of
	ess-r-versions-created here, just return the required value.

	* ess-site.el (ess-versions-created): Tidy up the code for calling
	older versions of R and Sqpe.  Old version did not work on Unix,
	since ess-sqpe-versions-created was not bound.	New version checks
	that variable is bound before using it.

	* ess-utils.el (ess-flatten-list): Standard defun needed for
	flattening a list.  Copied from lpr.el.

2004-07-01  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-inf.el (ess-quit): Delete call to ess-switch-to-ESS;
	ess-cleanup will have already done that.
	(ess-cleanup): Add save-excursion to preserve current buffer.

	* essd-r.el (ess-r-versions-created): New variable to store the
	names of the new defuns created.
	(ess-r-versions-create): Set ess-r-versions-created. Doc string
	update.

	* ess-site.el: Add the new R defuns, if any, to the "Other" menu
	under "Start Process".

	* ess-mode.el (ess-mode-menu): Add new submenu "Other" to "Start
	Process" where the other versions of R will be placed.

2004-06-30  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-mode.el (ess-mode-menu): Add entries to jump to top-level of
	ESS info file.

	* ess-cust.el (ess-rterm-versions): Condition initial value on
	ess-microsoft-p.

2004-06-29  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* Makefile (ELC): Add ess-toolbar.elc to list of .elc files.

2004-06-24  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-toolbar.el (ess-use-toolbar): Set to nil if images cannot be
	displayed on the running Emacs.

	* essd-r.el (ess-r-versions-create): Remove full pathname from
	versions of R executables.  Add note in the *ESS* buffer to say
	which new defuns have been created.

2004-06-23  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-toolbar.el (ess-use-toolbar): Default value should check if
	we are running XEmacs.	Other small doc updates to file made.

	* ess-utils.el (ess-uniq-list): New defun for removing duplicate
	strings from a list.

	* ess-site.el: Set up call to `ess-r-versions-create'.

	* essd-r.el (ess-r-versions-create): New function to auto-generate
	defuns to allow other versions of R to be called.

	* ess-cust.el (ess-r-versions): New variable to control which
	other versions of R are found.

2004-06-21  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-toolbar.el: Add test at end to check for toolbar support.

	* ess-mode.el (ess-mode-menu): Add Sqpe and S+6-existing to
	"Start Process" menu but their active state is determined by
	ess-microsoft-p and so will be greyed out unless on microsoft.
	(SAS-menu): Simple wrapper to report error if SAS invoked on
	microsoft machine.

2004-06-20  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* essd-sp6.el (S+6-mode): Hook in toolbar support.

	* essd-r.el (R-mode): Hook in toolbar support.

	* ess-toolbar.el: Update toolbar support so that we have only one
	ESS toolbar that can be used over multiple modes.  This makes it
	simpler to use I feel.

2004-05-22  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-inf.el (ess-eval-linewise): Try again to get the point at
	the end of the S buffer after evaluation.  Previous attempt still
	didn't work, but I forgot that I had set
	comint-scroll-to-bottom-on-output.  This version should work even
	with that comint var set to nil.

2004-05-18  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-inf.el (ess-eval-linewise): If eob, remember to go to the
	end of the S buffer after evaluation.  This was a bug that I
	introduced when introducing the ability to have R in different
	frames.

2004-05-17  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-fix-EQ-assign): new S source cleaners;
		    (ess-fix-dot-more) : ditto
	  added to ess-MM-fix-src's actions

2004-05-17  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-toolbar.el (ess-icon-directory): Need / after etc directory.

	* ess-mode.el (ess-mode-menu): Remove :help elements from menus,
	since XEmacs does not yet recognise it.

	* essd-els.el (ess-remote): Update doc string.
	(S+elsewhere, ESS-elsewhere): Add note in doc string to say these
	commands are obsolete and ess-remote should be used instead.

2004-05-13  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess.el: Update copyright; remove old comments; update URL.

	* ess-site.el (ess-etc-directory): Move out of ess-cust.el and
	into ess-site.el, otherwise various other .el files that are
	loaded before ess-cust will complain.

	* essl-bug.el: Comment possible use of ess-etc-directory here.

	* essl-s.el (ess-function-outline-file): Use ess-etc-directory.

	* essd-sas.el (ess-SAS-pre-run-hook): Use ess-etc-directory.

	* ess-toolbar.el (ess-icon-directory): Use ess-etc-directory.

	* ess-cust.el (ess-etc-directory): New variable.

	* ess-toolbar.el (ess-make-toolbar-R-emacs,
	ess-make-toolbar-S-emacs):  Since R and S are now on the menubar,
	use tool-bar-add-item-from-menu for consistency.

	* ess-mode.el (ess-mode-menu): Add sub menu to allow S, R, SAS to
	be started from menu.  Each menu item has a little tooltip help.

2004-05-10  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-toolbar.el
	(ess-make-toolbar-R-emacs,ess-make-toolbar-S-emacs): Check that
	tool-bar-map is non-nil before attempting copy-keymap (generates
	error on Emacs 21.3+).

2004-05-08  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-toolbar.el (ess-icon-directory): Guess default value based
	upon ess-lisp-directory.
	(ess-toolbar-R, ess-toolbar-S): Store toolbars here.
	(ess-make-toolbar-S): Make toolbar for S mode too, similar to R
	mode, but using new S-plus icons from David Smith.
	(ess-make-toolbar-S-emacs,ess-make-toolbar-S-xemacs): New defuns.

2004-05-07  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* essa-sas.el (ess-sas-submit-mac-virtual-pc): Assign :type to be
	boolean.   Reformat defcustoms (whitespace changes only).

	* essl-sas.el (sas-get-options, sas-file-name,
	ess-sas-run-make-regexp):  Correct :type to prevent mismatch in
	customization.

	* essa-sas.el (ess-sas-shell-buffer-remote-host): Ditto.

2004-05-06  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-toolbar.el (ess-make-toolbar-r-emacs): Use ess-load-file
	rather than ess-eval-buffer in toolbars.

	* ess-help.el (ess-display-help-on-object): Use ess-help-frame-alist.

	* ess-inf.el (ess-multi): Use inferior-ess-frame-alist.

	* ess-cust.el (ess-help-frame-alist, inferior-ess-frame-alist):
	New variables to store frame parameters for iESS buffers and help
	frames.
	(ess-help-own-frame, inferior-ess-own-frame): Doc fixes.

	* ess-help.el (ess-display-help-on-object): Fix bug introduced in
	5.2.0 (reported by Robert Hankin).  If ess-help-own-frame is nil,
	and we are currently in a help buffer, show new help buffer in
	same window.

2004-05-05  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-inf.el (ess-request-a-process): Use ess-show-buffer to
	display iESS buffer; update doc string.

2004-05-02  A.J. Rossini  <rossini@u.washington.edu>

	* essd-sp6.el (S+6-mode):
	* essd-sp5.el (S+5-mode):
	* essd-sp4.el (S+4-mode):
	* essd-s4.el (S4-mode):
	* essd-sp3.el (S+3-mode):
	* essd-s3.el (S3-mode): fixed imenu variable name, extended
	copyrights from 1997 to 2004.

	* essa-sas.el (ess-sas-image-viewer): Moved function after
	ess-sas-submit-method defvar, since we need that value to set this
	function.

2004-04-27  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess.el (ess-write-to-dribble-buffer): Check if
	ess-dribble-buffer has been deleted.  Remove the defadvice code
	that used to do this.

2004-04-26  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-inf.el (ess-switch-to-ESS): Use `ess-show-buffer' to show
	the iESS buffer.
	(ess-show-buffer): New function to be used when an iESS buffer is
	to be displayed.  See its doc string for the rules it follows as
	to how to display the iESS buffer.
	(ess-get-bufname,ess-get-buffers-in-frames,
	ess-buffer-visible-this-frame,ess-buffer-visible-other-frame): New
	helper functions for ess-show-buffer, adapted from iswitchb.el.

2004-04-22  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-cust.el (ess-speedbar-use-p, ess-funcmenu-use-p): Use
	fboundp.

	* ess-menu.el (ess-imenu-use-S): Change default value and update
	doc string.
	(ess-imenu-regexp-S-function): Delete unused variable.

	* ess-cust.el (ess-use-menus): Delete unused variable.
	(ess-imenu-use-p): Set default value to (fboundp 'imenu) rather
	than (featurep 'imenu) since the former is more useful for seeing
	whether Imenu is available.  (The latter is true only if Imenu has
	already been loaded.)

2004-04-19  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-help.el (ess-display-help-on-object): If ess-help-own-frame
	is 'one, use the dedicated frame.  Use pop-to-buffer rather than
	switch-to-buffer if currently in a help buffer,

	* ess-cust.el (ess-help-own-frame): Add new value 'one to specify
	that all help buffers should be displayed in one frame.

2004-04-18  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-help.el (ess-display-help-on-object): If ess-help-own-frame
	is true, use ess-help-own-frame function to display help buffer.
	(ess-help-own-frame): New function and variable to display all
	ESS help buffers into one frame.

	* ess-cust.el (ess-help-own-frame): New variable.
	(ess-help-kill-bogus-buffers): Change to ess-help group.
	(ess-help): New customize group.

	* ess-cust.el (inferior-ess-own-frame): New variable.

	* ess-inf.el (ess-switch-to-ESS): Respect inferior-ess-own-frame.
	(ess-multi): Use pop-to-buffer if process already running, and
	respect inferior-ess-own-frame.

2004-04-16  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-inf.el (ess-multi): Use pop-to-buffer rather than
	switch-to-buffer, so that special-display-regexps should work.

2004-04-15  Stephen Eglen  <stephen@bushmills.inf.ed.ac.uk>

	* ess-cust.el (inferior-ess-client-command): Set :group and :type.
	(R-editor, S-editor): reformat.
	(R-pager, ess-pager): reformat and allow type to be nil or string.

2004-03-31  A.J. Rossini  <rossini@u.washington.edu>

	* ess-site.el: added a more explicit commented out Windows
	example.  Cleaned up documentation inconsistencies for noweb/Rnw
	modes.

	* essd-r.el (R): added autoload cookie for XEmacs.  doc edits.
	(R-mode): added autoload cookie for XEmacs.
	Removed R-package generator; a better version is part of R
	(package.skeleton()).

	* ess-menu.el (ess-imenu-S-generic-expression): fixed imenu
	routine -- now provides links to functions, classes, methods, and
	"other" objects.

2004-03-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-els.el (ess-select-alist-dialect): (let* ..) : thanks to Na Li.

2004-03-04  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el (ess-restore-asm-extns): thanks to Ed Cashin

2004-02-19  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* essd-els.el (ess-select-alist-dialect): Use completing-read to
	select dialect.

2004-02-12  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* essl-s.el (ess-smart-underscore): Only be smart in buffers where
	`ess-language' is "S".

	* ess-site.el ("[ess-site:] require 'essd-els ..."): oRemove the
	code that fixes ess-smart-underscore in SAS mode.

2004-01-20  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* essl-s.el (ess-smart-underscore): Pressing _ twice inserts _
	rather than the assignment operator.

2004-01-19  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-cust.el (inferior-R-program-name): Customize.
	Add description of file to line 1.
	(ess-version): Change from defcustom to defvar;
	presumably no-one will want to customize this variable!	 Comment
	line prior to definiton already says that this variable is not
	user-changeable.
	(ess-dialect): Change from defcustom to defvar.

2003-12-08  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* ess-noweb.el (ess-eval-chunk): The code chunk is evaluated in a
	temp buffer, and should inherit the value of
	ess-local-process-name from the source value.  If the source
	buffer did not set ess-local-process-name, it is set once the
	chunk has been evaluated.

2003-11-24  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-emcs.el (replace-regexp-in-string): also needed for Emacs 20.

2003-11-06  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-S-loop-timeout): new variable (and same for	-XLS-)
	* essd-*.el  use these new customizable variables.

2003-11-05  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (inferior-ess): make comint-use-prompt-... buffer-local
	  such that we no longer "pollute" other comint modes such as M-x shell

2003-10-29  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-trns.el (ess-transcript-mode-map): add C-a := comint-bol
	* ess-inf.el (inferior-ess-mode-map):  ditto

2003-09-25  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (ess-dump-filename-template-proto): renamed,
	   new functionality: used as prototype

	* essd-*.el: ess-dump-filename-template now uses and modifies the
	       above prototype.

2003-08-19  Stephen Eglen  <stephen@gnu.org>

	* ess-help.el (ess-help-underline): New function to convert ^_H in
	help buffers to the underline face.

2003-08-05  Stephen Eglen  <stephen@gnu.org>

	* ess.el (ess-setq-vars-local): Prevent e.g.
	ess-local-process-name getting reset to nil when re-entering a
	code chunk in mixed mode buffers (like Latex/R).

2003-07-24  Stephen Eglen  <stephen@gnu.org>

	* essa-r.el (ess-r-var): New function for loading numbers from any
	Emacs buffer into an existing *R* process.

2003-01-01  Stephen Eglen  <eglen@pcg.wustl.edu>

	* ess-site.el (ess-rdired): Add autoload for ess-rdired.
	* ess-rdired.el: New file.

2002-11-12  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (Rnw-mode): new (experimental) for Sweave{R} editing.

2002-11-01  Stephen Eglen  <eglen@thalamus.wustl.edu>

	* essl-s.el (ess-help-R-sec-regex): Restrict regex so that capital
	letter must be at start of line.

2002-04-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-sp6.el (S+6-customize-alist): ess-setup-directory-function
	and other changes from Jeff Mincy; not yet fully tested.

2002-04-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-trns.el (ess-transcript-mode-menu): add ..DO-clean-region to
	menu, using new argument (prefix) for escaping read-only state.

2002-02-15  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (S-editing-alist): introduce S "global"
	  `inferior-S-language-start'

	* essd-r.el (R-customize-alist): use inferior-S-language-start above.
	* essd-sp[3-6].el, essd-s[34].el, essdsp6w.el, essd-els.elc -- ditto.

2002-02-13  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-cust.el (S-pager) and others: s/emacslient/emacsclient/

2002-01-26  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essddr.el (Rd-font): new function, put on C-c C-f à la TeX-font
	(Rd-font-list): e.g. `C-c C-f l' now surrounds word by \code{\link{.}}!

2002-01-16  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-menu.el (ess-imenu-S): use improved
	  ess-S-imenu-generic-expression (and clean up), by Stephen Eglen.

2002-01-15  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (S-editing-alist): new add-log-...regep from Stephen
	Eglen. Allows `C-x 4 a' (adding to Changelog) find the S function name.

	(R-help-sec-keys-alist): "Usage" and "Details" as the S lists.

2002-01-14  Richard Heiberger <rmh@surfer.stat.temple.edu>

	* ess-mous.el: ess-mous is now on submenu of C-mouse-3 in
	  ess-transript-mode, inferior-ess-mode, ess-mode.  This feature
	  is still beta.

2002-01-11  Richard Heiberger <rmh@surfer.stat.temple.edu>

	* ess-inf.el: remove .in.ESS
	* essd-r.el: first draft of options("STERM")

2002-01-10  Richard Heiberger <rmh@surfer.stat.temple.edu>

	* ess-mous.el: S-mouse-3 gets information from S/R about the
	highlighted phrase or about the word at the cursor location.

2002-01-10  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-help.el (ess-help-bogus-buffer-p): now also works in R when
	help.try.all.packages = TRUE.

2002-01-03  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-ddeclient-p): new function from Rich
	  and a few related changes

2001-10-16  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-execute-objects): use (number-to-string ..) for
	Emacs 21 (thanks to Stephen Eglen).
	* ess-trns.el: typo "o" fixed (S.Eglen)

2001-09-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-multi): .in.ESS <- TRUE for S dialects

2001-09-20  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el and others: do use ess-running-xemacs from ess-emcs.el!

	* ess-menu.el: fix the (require 'imenu ..) [for E 19.34]

2001-09-05  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essddr.el (Rd-mode-map): add C-c C-v (help)

2001-08-31  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-menu.el (require 'imenu): try to do this only when
	available [not tested; I have imenu "everywhere"]


2001-08-30  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-narrow-to-defun): new function

2001-08-21  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-directory-function): also ess-cust.el, essd-sp6.el:
	Implement Jeff Mincy's patches for new function
	--- currently only for S+6 (Unix) -- FIXME: Support R, other Spluses

2001-08-10  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess.el: (defadvice ess-write-to-dribble-buffer ....) from Jeff Mincy

2001-06-19  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-utils.el (nuke-trailing-whitespace-p): make interactive; cosmetic

2001-03-02  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el: On Linux, default to S+5, since there's no S+3

2001-02-28  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-utils.el (ess-space-around): new utility

	* essd-r.el (R-fix-T-F): also fix after "_"

	* essl-s.el (ess-fix-miscellaneous): Fix bug which broke "<=" & ">="
	  Further fix bug which broke "<<-" (and "->").
	  separate e.g., "){" ; space around "else".

2000-10-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-smart-underscore): remove extra spaces when
	ess-S-assign is used.

2000-10-11  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-smart-underscore): new function, assigned to "_" key.

2000-10-09  A.J. Rossini  <rossini@biostat.washington.edu>

	* /home/ess/src/cvsroot/gnu/ess/lisp/ess-vars.el:
	Merged with changes in another location.

2000-10-09  maechler  <maechler@rossini.YP.biostat>

	* /home/ess/src/cvsroot/gnu/ess/lisp/ChangeLog,
	 /home/ess/src/cvsroot/gnu/ess/lisp/essl-s.el:
	new (ess-fix-miscellaneous) & (ess-toggle-underscore)

2000-10-09  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-fix-miscellaneous): new function for prettifying
	S language code.
	(ess-toggle-underscore): new function for "_" toggling.

2000-10-04  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-s.el (ess-add-MM-keys): define-key "_" to ess-S-assign.

	* ess-cust.el (ess-S-assign): new variable (" <- ") for left assign.
	* ess-vars.el (ess-S-assign): --ditto--

2000-08-16  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (R): Win32: don't give spurious warning anymore.

2000-08-09  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-help.el (ess-display-help-on-object): Inherit syntax-table;
	  this should make the "default prompt" work for "help inside help".

2000-07-08  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-sas.el (SAS-mode-font-lock-keywords): only when
	   window-system! fixes "emacs -nw -f R"

2000-06-28  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el : load-path setting *MUST* come first.

2000-04-14  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-dir-modtime): RMH: use file-directory-p instead
	of string-match.

2000-04-04  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-eval-line-and-step): new even-empty argument,
	[prefix] allowing to send even empty lines to the ESS process.

	* ess-vars.el: New logical variable ess-eval-empty.

	* ess-inf.el (ess-command): applied the "FIXME": ess-command
	should have two arguments only. -- Few adjustments in other *.el files.

2000-04-03  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el and other files:
	Replace (function) ess-eval-visibly by ess-eval-linewise
	Replace (function) ess-eval-line-and-next-line by *-line-and-step

2000-03-31  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-next-code-line): new function from Stephen Eglen
	  (ess-eval-line-and-next-line): new prefix arg for turning off
	  the use of new ess-next-code-line.

	  Further : Use (forward-line 1) instead of (next-line 1).

	* ess-mode.el: added a few autoloads (and a comment for AJR !?).
	  s/"Step through line"/"Eval line & step"/
	  white space [n*8 column starts]

	* ess-inf.el (inferior-R-input-sender): Fixed the regexps for
	help() and {even more} for ?<...>, using new variable
	ess-help-arg-regexp {in ess-vars.el}.

2000-03-30  Martin Maechler  <maechler@stat.math.ethz.ch>

	* almost ALL lisp files :  Docstring fixes, thanks to
	  Stephen Eglen <stephen@anc.ed.ac.uk>.

2000-03-21  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-vars.el (ess-temp-point): new for fixing multiline commands
	in transcript.	Similar fix in
	* ess-trns.el, and
	* ess-inf.el. --- really all by RMH!

	* ess.el (cadr): define if not available.

2000-03-20  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-help.el (ess-help-error-buffer-p): new utility, improve
	detection of help error messages for
	(ess-display-help-on-object).

	* essl-sas.el: new variables sas-white-chars & sas-comment-comment-chars
	* essl-sas.el: (beginning-of-sas-statement): don't quote blank

2000-02-10  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-help.el: Add menu; fix ess-display-sec-map

	* essddr.el (Rd-mode): one menu entry.

	* essd-sp5.el (S+5-customize-alist): search-list-command=search("paths")

1999-12-21  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-sp5.el: S+5-customize-alist was there *TWICE*
		finally replaced cat by "slynx -dump"

1999-12-08  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essl-sta.el (setq max-lisp-eval-depth): increase necessary

1999-11-22  ess	 <ess@aleph.YP.biostat>

	* ess-vars.el: Updated to 5.1.11

1999-11-17  ess	 <ess@aleph.YP.biostat>

	* essddr.el:
	'bold isn't defined in XEmacs.	Using reference-face instead of Rd-bold-face.

1999-11-16  ess	 <ess@aleph.YP.biostat>

	* ess-vars.el: Fixed small version update errors

	* Makefile, ess-help.el, ess-site.el, essd-els.el, make-regexp.el, noweb-mode.el:
	updated version numbers

	* essl-sta.el: added local variables for editing and indexing.

	* essl-sta.el: added Brendan's suggested function.

	* essl-sta.el:
	added make-regexp to ESS, and finished integrating Brendan's code.
	Need to test it now!

	* make-regexp.el: needed for Stata-mode extensions

	* essl-sta.el: added Brendan Halpin's corrections.

	* ess-inf.el: concat needs number-to-string conversion.

	* essd-omg.el: Omegahat fixes (for commandline flags)

1999-11-11  ess	 <ess@aleph.YP.biostat>

	* noweb-mode.el:
	C-c C-n shouldn't be TeX-normalmode, since it is too close to
	submit-line with ESS!  (overwrite).

	* essd-omg.el: Use prefix for setting Omegahat arguments.

1999-11-10  rossini  <rossini@biostat.washington.edu>

	* essl-omg.el: S- becomes OMG-
	Comments redone (to use //, ///, and //// for levels of indentation)
	OMG-syntax started, variable defined, needs to be fixed.

	* essd-omg.el:
	further Omegahat dialect changes (use OMG syntax, which needs fixing!)

1999-11-05  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess.el: added a definition of (functionp ..) if there isn't any


1999-11-05   Martin Maechler  <maechler@stat.math.ethz.ch>

	* ChangeLog, ess.el, noweb-mode.el: functionp definition if necessary

	* noweb-mode.el: functionp for	emacs-19.34

1999-11-04  A.J. Rossini  <rossini@biostat.washington.edu>

	* TONS of things -- see ../ChangeLog

1999-11-04  rossini  <rossini@biostat.washington.edu>

	* essd-els.el: fixed paren error.

	* Makefile, ess-site.el, ess-vars.el, essd-sas.el:
	Changed version numbers

1999-11-03  rossini  <rossini@biostat.washington.edu>

	* Makefile, ess-inf.el, ess-site.el, ess-vars.el, essd-sp5.el:
	Changes for ESS-elsewhere.

	* essd-els.el: added a generic ESS-elsewhere function.

1999-10-06  Anthony Rossini  <rossini@aleph.YP.biostat>

	* ess-inf.el: fixed extraneous echoes in Stata.

1999-10-04   rossini  <rossini@biostat.washington.edu>

	* essd-sta.el: fset both stata-mode and Stata-mode.

	* ess-site.el:
	cleaned up autoload conflicts between 2 local (AJR) copies.

1999-09-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ChangeLog, Makefile: don't byte-compile ess-debug.el

	* ChangeLog, essd-r.el: for R, use help(. , htmlhelp=F)


1999-09-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* Makefile (SOURCES): use new $(TOCOMPILE) -- don't ess-debug.el !

1999-09-27  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (R-customize-alist): help( .. htmlhelp = FALSE)

Wed Sep 15 22:34:37 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-inf.el (inferior-ess-mode): preliminary support for Omegahat.

Wed Sep 15 22:21:42 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* essd-omg.el (omegahat-mode): fset for OMG-mode. use it.
		(omegahat): fset for OMG.  use it.
		Documentation fixes.

Wed Sep 15 22:20:37 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-site.el (essd-omg): require this, now.

Wed Sep 15 22:19:08 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-site.el: added omegahat, comment about ssh (for ess-elsewhere)

Wed Sep 15 22:17:04 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-vars.el (inferior-STA-program-name): documentation fixes

Wed Sep 15 22:16:55 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-vars.el (inferior-OMG-program-name): new variable

Tue Sep 14 22:55:55 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* essd-xls.el (xlispstat-mode): added as a synonym.

Tue Sep 14 16:53:21 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* noweb-mode.el: Emacs/XEmacs compatibility done.

Tue Sep 14 16:53:07 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-debug.el: This is customized for me (AJR).

Tue Sep 14 16:52:35 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-site.el: added noweb-mode by default.

Tue Sep 14 16:10:04 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-noweb.el (global-font-lock-mode): set true to prevent XEmacs
	from barfing.

Tue Sep 14 13:26:36 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess?-sta.el: cleaned up stata mode to work.

Tue Sep 14 11:06:38 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-inf.el: white space, documentation, stata hacks.

1999-09-06  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essddr.el (Rd-indent-level): default 2 (back from 4):
	We need horizontal space, and there's not a lot of nesting.

1999-09-01  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el : add "Switch Process" menu entry to [ESS] menu.

1999-07-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el : Define cheap (line-end-position) if not there
	[e.g. for GNU emacs 19.34]

1999-07-22  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-mode.el (ess-beginning-of-function):
	Delimit (search-forward "(" ..) ---> fixed bug !

1999-07-21  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (ess-eval-function):  Use (ess-end-function) only,
	since that now returns beginning & end;
	further, use (ess-extract-word-name) only once.

	* ess-mode.el (ess-beginning-of-function): return beginning
	*	      (ess-end-of-function): accept optional `beginning'
		argument;  return BOTH beginning & end
	*	      (ess-mark-function): use new beg/end functions.

1999-07-06  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (R-fix-T-F): Fix buglet: should catch more cases


1999-06-17  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-*.el (ess-loop-timeout): Default multiplied by 5 to 500000.

	* essd-R.el -- simplified primary-prompt !

1999-04-23  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el (auto-mode-alist): Change regexp's in order to work
	with NTemacs which is has a non-case-sensitive `find-file'.

1999-04-05  A.J. Rossini  <rossini@biostat.washington.edu>

	* ess-site.el, ess-vars.el: text from 5.1.7 to 5.1.8

	* ess-site.el: cleaned up misguided comment.

	* ess-site.el: cleaned up, removed R unix/microsoft hack.

	* essd-r.el: using a solitary R.

	* ess-inf.el:
	conditioned out the slowdown in ess-prompt-wait for Microsoft.

	* ChangeLog: doc updates

1999-04-05  A.J. Rossini  <rossini@biostat.washington.edu>

	* ess.el: franz.stat.wisc.edu -> ess.stat.wisc.edu

	* ess-site.el, ess-vars.el: 5.1.6 to 5.1.7 changes for possible release

	* ess-inf.el: ess-prompt-wait duration changed?

1999-04-01  maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el: typo

1999-04-01  A.J. Rossini  <rossini@biostat.washington.edu>

	* ess-site.el: about to release 5.1.6

	* ess-vars.el: anything else?

1999-03-31  A.J. Rossini  <rossini@biostat.washington.edu>

	* ess-iw32.el: whitespace modifications.

	* ChangeLog: *** empty log message ***

	* essd-r.el:
	reverted.  We can simply leave R as given, and not worry about R-unix (thanks to Martin).

	* essd-r.el: R -> R-unix.

	* ess-inf.el:
	sleep-fors are commented out except for Microsoft "operating systems", sigh...

	* essd-r.el: preliminary changes

Wed Mar 31 15:46:37 1999  A.J. Rossini	<rossini@biostat.washington.edu>

	* essd-r.el (R): reverted.  Martin fixed this right in ess-site.
	* essd-r.el (R-unix): renamed from R.
	* ess-inf.el (ess-command): sleep-for only used for Splus 4.5,
	i.e. Microsoft "operating systems", sigh.

1999-03-18  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el (auto-mode-alist): OOps for last change *.sty became
	ESS S-transcript; now fixed

1999-03-17  A.J. Rossini  <rossini@biostat.washington.edu>

	* essd-r.el, ess-site.el, ess-vars.el: RMH's changes

1999-03-16  A.J. Rossini  <rossini@biostat.washington.edu>

	* essd-r32-sh-dos.el, essd-sp4com.el: MS Dos stuff for R, S+4.x

	* ChangeLog: Prep for 5.1.4

	* essd-sp4.el, ess-iw32.el: RMH changes.

	* ess-site.el: Merged RMH's work.

	* ess-vars.el: incremented.

	* ess-inf.el: RMH's changes.

1999-03-16  Martin Maechler <maechler@stat.math.ethz.ch>

	* ChangeLog: mini change "foobar.Sout-45"

	* ess-site.el:
	auto-mode-alist:  "foobar.Sout-4.5" also turns on S-transcript-mode

1999-03-16  A.J. Rossini  <rossini@biostat.washington.edu>

	* essd-sp4.el, ess-iw32.el: RMH changes.

	* ess-site.el: Merged RMH's work.

	* ess-vars.el: incremented.

	* ess-inf.el: RMH's changes.

1999-03-16  maechler  <maechler@stat.math.ethz.ch>

	* ChangeLog: mini change "foobar.Sout-45"

	* ess-site.el:
	auto-mode-alist:  "foobar.Sout-4.5" also turns on S-transcript-mode


1999-03-16  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el (auto-mode-alist): "foobar.Sout-4.5" also turns on S-transcript-mode

1999-03-03  A.J. Rossini  <rossini@biostat.washington.edu>

	* Makefile: updated version information

	converted s+3 to sp3.

	* ess-vars.el: updated version information.

	* ess-iw32-load-file.el, essd-s+3.el, essd-s+4.el, essd-s+5.el, essd-s_2b4-msdos-existing.el, essd-s_2b4-msdos.el:
	Tidied up ess-iw32*.el files.

	* ess-iw32.el: copied all changes from ess-iw32-load-file.el here.

	* ess-iw32-load-file.el: fixed.

	* essd-s_2b4.el:
	essd-s_2b4-msdos*.el were not needed.  Contents moved into base file.

	* ess-iw32-load-file.el, ess-iw32.el, essd-r32.el, essd-s_2b4-msdos-existing.el, essd-s_2b4-msdos.el, essd-s_2b4.el, msdos.el:
	RMH's changes, up to March 2nd

1999-02-24  A.J. Rossini  <rossini@biostat.washington.edu>

	* ess-iw32.el: temp val left in distribution.  whoops (RMH).

1999-02-22  A.J. Rossini  <rossini@biostat.washington.edu>

	* essd-els.el, essd-s3.el, essd-s4.el, essd-sta.el, ess-site.el, essd-sp4.el, essd-sp5.el, essd-sp3.el:
	Removed s+# to sp# for S-PLUS commands

1999-02-12  Martin Maechler  <maechler@stat.math.ethz.ch>

	* Makefile: emacs, not "19.34"

1999-02-10  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-sas.el: added RMH's new fixes for the 5.1.2 version.

1999-02-02  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el: (last commit was with unsaved file)

	* ChangeLog, ess-inf.el:
	fix regex for "help(..);" also work for "?" with R-input-sender



1999-02-02  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-inf.el (inferior-R-input-sender): Change the regexp such
	that e.g. "help(pt, offline=T)" is treated as normal command;
	New: "?lm" (e.g.) is also recognized as help command

Mon Dec 14 18:04:45 1998  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-mode.el: fixed copyright and header information

	* ess-site.el: commented out SHOME definition.

Fri Dec 11 19:51:18 1998  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-vars.el: fixed copyright, rossini's email address.

	* ess-iw32.el: fixed rossini's email address, headers, copyright.

	* essd-els.el, essd-s+4.el: fixed rossini's email address.

	* essd-sq4.el: fixed copyright and header attributions.

	* essd-els.el: fixed header files and copyright.

	* essd-s+4.el: added changes to copyright and header docs.

	* ess-vars.el: Merged RMH's changes.

	* ess-iw32.el, essd-els.el, essd-s+4.el, essd-sq4.el:
	New files for ESS for Splus/MSW/NT/98/95
	New files for remote-ESS on Unix.

	* ess-site.el: Added RMH's changes for Microsoft Windows and Splus.

Mon Nov 30 17:37:57 1998  hornik  <hornik@pyrite>

	* Makefile:
	Add essd-s+5.el to SOURCES (as it gets required in ess-site).

Mon Nov 23 20:03:17 1998  A.J. Rossini	<rossini@biostat.washington.edu>

	* ChangeLog: *** empty log message ***

Fri Nov 20 20:57:33 1998  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-vars.el: ess-help-w3-url-prefix points to pyrite.

	* ess-vars.el:
	removed spurrious comment about generic function, in front of a variable.

	* essd-s+5.el: trimmed out old S4 stuff.

Mon Nov 16 17:29:25 1998  Martin Maechler  <maechler@...>

	* ess-inf.el: do not need comint echo anymore..

Sat Nov 14 00:23:19 1998  A.J. Rossini	<rossini@biostat.washington.edu>

	* ChangeLog: whitespace editing.

Fri Nov 13 18:25:51 1998  A.J. Rossini	<rossini@biostat.washington.edu>

	* ess-site.el: added sample entry for S+5.

	* ChangeLog: *** empty log message ***

	* ess-site.el: added suffix for StatSci's script files.

Thu Nov 12 17:27:30 1998  Martin Maechler  <maechler@...>

	* essd-r.el, essd-s+3.el, essd-s+5.el, essd-s3.el:
	newline in dribble buff

	* ess-inf.el:
	more details in prompt for ess-get-dir; more dribble; WHITE SPACE

	* ess.el: slightly better dribble output

	* essd-s4.el: drop doubled comments

	* ess-vars.el: .

Wed Nov 11 12:45:15 1998  Martin Maechler  <maechler@...>

	* essd-s+5.el: omit .Smode() extras; new "S+" instead of "S+3"

	* essl-s.el: new "S+" instead of "S+3"

	* ess-inf.el: comint-echo : OFF for S+5

	* essd-s3.el: comments only

	* essd-s+3.el: comment out ess-mode-edit

	* Makefile, ess-vars.el: new version numbers

	* essd-s+5.el: several more s4 -> s+5 changes; still not ok

	* essd-s+3.el: transpose to defs

	* ess-vars.el: require s+5

Tue Nov 10 17:45:11 1998  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-site.el: s+5 is now distributed

	* essd-s+5.el: provide typo fixed

Mon Nov	 9 23:28:14 1998  A.J. Rossini	<rossini@biostat.washington.edu>

	* ChangeLog, Makefile, ess-site.el: New material for Makefiles

	* essl-sta.el: removed possible problems from stata mode.
	-- provide 'essl-sta

	* essd-s+5.el: This is for Splus5, based on S4.

	* ess-web.nw: last change, sigh.

	* ess-web.nw: emacs lisp mode is wrong, sigh.

	* ess-web.nw: Contains interface code between Noweb and ESS

	* ChangeLog: added stata-dialect/lang to makefile

	* Makefile: added Stata stuff.

Thu Sep 24 23:32:14 1998  A.J. Rossini	<rossini@biostat.washington.edu>

	* ChangeLog: more stuff.

	* essd-sta.el: should be sta, not stt

	* ChangeLog: update for ess-site.

	* ess-site.el: added stata mode, which is now STA (ref: Thomas Lumley)

Thu Sep 17 09:11:51 1998  Martin Maechler  <maechler@...>

	* ChangeLog, ess-utils.el: several  small things

Fri Sep 11 16:20:14 1998  Martin Maechler  <maechler@...>

	* essd-r.el: (R-fix-T-F): new function

Fri Sep 11 15:39:57 1998  Martin Maechler  <maechler@...>

	* essd-s4.el: Extraneous end deleted

	* ess.el ess-inf.el ess-mode.el Makefile: Adaptions to new ess-utils.

	* ess-utils.el: new file for ``General Utilities''
			useful and usable *outside* ESS.

1998-09-09  A.J. Rossini  <rossini@biostat.washington.edu>

	* essd-sta.el: new file
		(STA-customize-alist): edited according to essl-sta.el.
		(STA-mode): New function
		(stata): New function
		(STA-transcript-mode): New function

	* Makefile (BATCHFLAGS): --no-init-file, not --no-init-fil

Tue Sep	 8 19:18:07 1998  Martin Maechler  <maechler@..>

	* essl-s.el: added  "&optional dont-ask" argument to
	ess-dump-to-src, ess-fix-comments,.... ess-MM-fix-src

Mon Sep	 7 18:26:47 1998  Martin Maechler  <maechler@...>

	* essl-s.el (ess-time-string): 4 digit year!

Wed Aug 26 14:16:35 1998  Martin Maechler  <maechler@...>

	* essl-s.el (S-editing-alist): font-lock-defaults: treat "." as
	word constituent (from Kurt).

Thu Aug 20 08:45:11 1998  Martin Maechler  <maechler@...>

	* essddr.el (Rd-section-names): and (Rd-keywords): expanded
	according to Kurt's suggestion.

Tue Aug 18 10:42:08 1998  Martin Maechler  <maechler@stat.math.ethz.ch>maechler

	* essd-s+3.el (S+3-dialect-name): new variable for customization.

Tue Aug 18 10:28:22 1998  Martin Maechler  <maechler@stat.math.ethz.ch>

	* essd-r.el (R): add the "--no-readline" argument to r-start-args.

Tue Aug 14 18:32:11 1998  Martin Maechler  <maechler@stat.math.ethz.ch>

	* ess-vars.el: new version "pre5.1"
	* Makefile: ditto
	* essl-s.el: renamed "ease:time-string" to "ess-time-string";
		cleaned up

Mon Apr	 6 11:27:52 1998  Tony Rossini	<rossini@matthias>

	* ess-inf.el (ess-object-names):
	* ess-inf.el (ess-execute-objects): add argument to call to
	inferior-ess-objects-command, for S4 (suggested by Stephen Pope).

Mon Apr	 6 11:22:22 1998  Tony Rossini	<rossini@matthias>

	* ess-vars.el (inferior-ess-font-lock-keywords): change, as
	suggested by Stephen Pope (remove parens).

Mon Dec 15 19:17:27 1997  Anthony Rossini  <rossini@stat.sc.edu>

	* essd-s4.el (S4-mode): New function, use it.

Wed Dec 10 10:33:59 1997  Anthony Rossini  <rossini@hsph.harvard.edu>

	* essd-xls.el: make sure that the major-mode is 'XLS-mode (might
	need to do this for _all_ modes :-(.  But let's first see if
	anything breaks.

Tue Dec	 9 17:54:31 1997  Anthony Rossini  <rossini@stat.sc.edu>

	* essd-r.el: removed non-necessary autoload for a non-existant
	function (was intended for start-args, but never was written or
	used).

Tue Dec	 9 15:45:18 1997  Anthony Rossini  <rossini@stat.sc.edu>

	* essddr.el: one too many parens.

Tue Dec	 9 15:44:23 1997  Anthony Rossini  <rossini@stat.sc.edu>

	* essddr.el: added commented out face.	DB's error doesn't exist
	for me, though.

Fri Dec	 5 10:12:54 1997  Anthony Rossini  <rossini@stat.sc.edu>

	* ess-site.el: added comments about Emacs 20.2 errors.

Fri Dec	 5 10:09:59 1997  Anthony Rossini  <rossini@stat.sc.edu>

	* CVS (ChangeLog): Starting 5.1 series.
